














                       SAIL EDITING ENVIRONMENT
                             VERSION 2.00
                           OPERATOR'S GUIDE
























                          Software Creations




















ISBN 0-944068-00-6

First Printing:  December, 1987.
Printed in the United States of America.


Copyright (C) Software Creations 1986, 1987.

All rights reserved.  No part of this publication may be reproduced,
stored in a retrieval system, or transmitted, in any form or by any
means, electronic, optical, magnetic, optoelectronic, mechanical,
photostatic, or otherwise, without the prior written permission of the
publisher.

No part of this document may be translated into a foreign language, and
no foreign language translation of this document may be translated back
into English, without the prior expressed written permission of the
publisher.



ERRORS OR OMISSIONS

The information in this document is subject to change without notice
and does not represent a committment on the part of Software
Creations.  The software described in this document is furnished under
a license agreement and/or a nondisclosure agreement.  This
documentation and the software may be used or copied only in accordance
with the terms of that agreement.

While every measure has been taken to ensure the accuracy of the
information contained within this manual, and for the workability of
the software, if you have a problem with this software, or a question
or a comment about the software described within this manual, or about
this manual itself, please complete the Software Problem Report Form at
the back of this manual.

Return completed Software Problem Reports to Software Creations.  All
Software Problem Reports become the property of Software Creations.
When communicating, if you wish your communication acknowledged, please
include a self-addressed, stamped envelope.  In general, comments from
registered users are given higher priority.














LICENSE AGREEMENT

By accepting and using this software, you acknowledge that this
software may not suit your particular requirements, or be completely
trouble free.  The software will perform as described when the
instructions are followed and with proper application.  Software
Creations will not assume responsibility for errors in the
documentation or problems resulting from use of this software.

SAIL is protected by United States Copyright Law and International
Treaty provisions.  Non-registered users of SAIL are licensed only to
use the program on a trial basis for the sole purpose of determining
whether or not it meets their requirements.  All other use requires
registration.

Any other use of non-registered copies of SAIL by any person, business,
corporation, government organization, or any other entity is strictly
forbidden and is a violation of this license agreement.  Registration
permits a single user a license to use SAIL on a single CPU in a
single-tasking, non-networked, non-shared operating environment.

All users are granted a limited license to copy SAIL Version 2.00 for
the trial use of others.  Under this agreement, you may NOT:

1) Distribute the program in connection with any other product or
   service, or as part of a corporate or institutionally-sponsored
   distribution.

2) Charge a fee for this program, with the exception of registered
   user groups who may charge cost-based fee (not to exceed $10) to
   cover their own costs of floppies and advertising.  The user's
   payment of a distribution fee to such a distribution group does
   not constitute an official SAIL registration.

3) Distribute the program or its documentation in modified form.



DISCLAIMER OF WARRANTIES

Software Creations provides this product on an "as is" basis.  Software
Creations shall have no liability or responsibility to any user or any
other person or entity with respect to any liability, loss or damage
caused or alleged to be caused directly or indirectly by this product,
including but not limited to any interruption of service, loss of
business or anticipatory profits or consequential damages resulting










from the use or operation of this product.

SOFTWARE CREATIONS MAKES NO WARRANTIES, EITHER EXPRESS OR IMPLIED,
REGARDING THIS PRODUCT, ITS MERCHANTABILITY AND/OR ITS FITNESS FOR A
PARTICULAR PURPOSE.  BY USING THIS PRODUCT, YOU AGREE THAT SOFTWARE
CREATIONS SHALL NOT BE LIABLE FOR ANY CONSEQUENTIAL DAMAGES, EVEN IF
SOFTWARE CREATIONS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
DAMAGES.

Should any part of this agreement be held invalid, the remainder of the
agreement will still be in effect.  This agreement can only be modified
by a written statement from Software Creations.



CONTROLLING LAW

This License Agreement shall be construed and controlled by the laws of
the State of Hawaii and United States copyright laws.





TRADEMARKS

While Software Creations has been conscientious in its attempts to
supply trademark information about company names, products, and
services mentioned in this publication, the trademarks listed below
were derived from various sources, and Software Creations cannot attest
to the accuracy of trademark information listed below.

IBM, IBM-PC, IBM-PC-AT, IBM-PS/2, IBM Personal Computer, IBM Personal
System/2, and PC-DOS are registered trademarks of International
Business Machines Corporation.  WordStar is a trademark of MicroPro
International Corporation.  UNIX is a trademark of Bell Laboratories.
MS-DOS, XENIX, and MicroSoft are registered trademarks of Microsoft
Corporation.  Brief is a trademark of UnderWare, Inc.  Epsilon is a
trademark of Lugaru Software Ltd.  DEC, Digital, and VAX are registered
trademarks of Digital Equipment Corporation.

SAIL is a copyrighted editor marketed by Software Creations.  EMACS and
GNU EMACS are public domain text editors designed by Richard Stallman
at the Massachusetts Institute of Technology.  MicroEMACS (uEMACS) is
the name of a public domain text editor originated by Dave Conroy and
modified by Steve Wilhite, George Jones, and Daniel Lawrence.










ABOUT THIS MANUAL

This Operator's Guide was prepared for publication with SAIL.  Drafts
written with SAIL were passed to the formatting program, ROFF4, and the
output printed on a laser printer.  Camera-ready material was then
collated into book form.  The total registration cost of the software
used for this publication is less than $100.00;  this is because SAIL
is shareware, and ROFF4 is in the public domain.  SUPPORT SHAREWARE.
















































                            WELCOME TO SAIL



Thank you for your contribution.  We at Software Creations sincerely
hope that you like your software as it was designed for maximum
performance.

Your software is just one of our line of innovative applications.  So
as to serve the widest possible audience, we have chosen to provide all
software on disk under the User-Supported concept.

Your contribution ensures that quality software at reasonable prices
will always be available.

We know that you'll find SAIL easy to use and adapt to your work.  Here
is a procedure that will help you to take the plunge and speed up the
learning process:


     1.  Check the configuration.  SAIL must be installed properly.

     2.  Run the demo.  Once SAIL is configured, you can run the demo
         program to learn about editing in a multi-window environment.

     3.  Do the tutorials.  The tutorials are designed to familiarize
         you with the editor.

     4.  Send us your comments.  As shareware, SAIL will be improved
         mainly through user comments.  The more useful comments you
         send us, the better future versions will be.

     5.  Tell your friends about SAIL.  By forming your own group,
         you will be able to understand and use of all its features.


Once again, thank you for entrusting us with your software needs.


Aloha nui loa,


Software Creations













                               CONTENTS


ABOUT THIS MANUAL
WELCOME TO SAIL
HOW THIS MANUAL IS ORGANIZED
ADDITIONAL INFORMATION
SAIL COMMAND ABBREVIATIONS
NOTATION


CHAPTER 1  INTRODUCTION
   Genealogy of SAIL                                    1-3


CHAPTER 2  INSTALLING SAIL
   DISTRIBUTION DISK FILES                              2-1
   EXECUTION ENVIRONMENT                                2-2
   TWO-DRIVE INSTALLATION                               2-4
   ONE-DRIVE INSTALLATION                               2-4
   HARD DISK INSTALLATION                               2-5
   TESTING YOUR INSTALLATION                            2-5


CHAPTER 3  STARTING SAIL
   STARTING WITHOUT A FILE NAME                         3-1
   STARTING WITH A FILE NAME                            3-1
   STARTING WITH TWO OR MORE FILE NAMES                 3-2
   COMMAND LINE WILDCARDS                               3-3
      ? Wild Card                                       3-3
      * Wild Card                                       3-4
   COMMAND LINE OPTIONS                                 3-4
   EMACS EMULATION MODE                                 3-6
   DISPLAY SPEED                                        3-6
   VIEWING FILES                                        3-6
   VERSION NUMBER                                       3-6
   COMMAND LINE HELP                                    3-7
   COMBINING COMMAND LINE OPTIONS                       3-7
   AUTOMATING COMMAND LINE OPTIONS                      3-7
   CHANGING THE TEXT COLORS                             3-8
      Color Installation Menu                           3-8
      Changing foreground and background                3-9
      Moving to the next field                          3-9
      Saving the color settings                         3-9
      Exiting color installation                        3-9











CHAPTER 4  BASIC EDITING
   INSERTING TEXT                                       4-1
      About modes                                       4-1
   COMMANDS                                             4-2
   THE CURSOR                                           4-3
   CURSOR KEYS                                          4-3
      Moving by Characters                              4-3
      Moving by Pages                                   4-3
      Moving by Paragraphs                              4-3
   CONTROL + CURSOR KEYS                                4-4
      Moving by Words                                   4-4
      Moving to the Start or End of a Line              4-4
      Moving to the Top or Bottom of the Buffer         4-4
      Rolling the Screen Up or Down                     4-4
   DELETING TEXT                                        4-4
      Deleting characters                               4-5
      Deleting words                                    4-5
      Deleting to the end of the sentence               4-6
      Deleting blank lines                              4-6
      Deleting paragraphs                               4-6
   NUMERIC ARGUMENTS                                    4-7
   EXITING SAIL                                         4-7
      Saving your work                                  4-7
      Quitting to DOS                                   4-8


CHAPTER 5  THE SCREEN
   WINDOWS                                              5-1
      Status lines                                      5-2
      Edit indicator                                    5-3
      Edit modes                                        5-3
      Wrap mode (WRAP)                                  5-4
      C mode (CMODE)                                    5-4
      Exact mode (EXACT)                                5-5
      View mode (VIEW)                                  5-5
      Overstrike mode (OVER)                            5-5
      Changing Edit Modes                               5-5
      Buffer Name                                       5-7
      File Name                                         5-7
   MESSAGE LINE                                         5-7
















CHAPTER 6  ENTERING COMMANDS
   COMPLETING COMMANDS                                  6-1
   CANCELLING COMMANDS                                  6-2
   NUMERIC ARGUMENTS:  REPEATING COMMANDS               6-2
      SAIL'S DEFAULT ASSIGNMENTS                        6-3


CHAPTER 8  ADVANCED TOPICS
   COMMAND ASSIGNMENTS                                  8-1
      Key sequences                                     8-2
      Mnemonic names                                    8-2
   MACRO FILES AND BUFFERS                              8-3
      Writing Command Files/Buffers                     8-3
      Sample macros                                     8-4
      Executing command files                           8-5
   MACRO DEBUGGING FACILITIES                           8-5
   CUSTOMIZATION                                        8-6
   DOS INTERFACE                                        8-6
   RUNNING A DOS COMMAND                                8-6
   DOS AS A CHILD PROCESS                               8-7
   DESKTOP PUBLISHING                                   8-8
   SOFTWARE DEVELOPMENT                                 8-9


CHAPTER 9  COMMAND REFERENCE
   COMMAND DESCRIPTION FORMAT                           9-1
   abort                                                9-2
   assign_key                                           9-2
   begin_macro                                          9-3
   bol                                                  9-3
   bop                                                  9-4
   bottom                                               9-4
   capitalize_word                                      9-5
   caps_block                                           9-5
   caps_word                                            9-5
   center_cursor                                        9-6
   close_other_windows                                  9-6
   copy_block                                           9-6
   delete_blank_lines                                   9-7
   delete_block                                         9-7
   delete_buffer                                        9-8
   delete_left                                          9-8
   delete_paragraph                                     9-9
   delete_right                                         9-9
   delete_to_eol                                        9-9
   delete_word_left                                     9-10










   delete_word_right                                    9-10
   dos_command                                          9-10
   dos_shell                                            9-11
   down                                                 9-12
   edit_buffer                                          9-12
   edit_file                                            9-12
   end_macro                                            9-13
   enlarge                                              9-13
   eol                                                  9-13
   eop                                                  9-14
   exchange                                             9-14
   execute_buffer                                       9-14
   execute_file                                         9-15
   execute_macro                                        9-15
   free_key                                             9-16
   goto                                                 9-16
   help                                                 9-16
   justify                                              9-17
   left                                                 9-17
   list_buffers                                         9-18
   lower_block                                          9-18
   lower_word                                           9-18
   merge_file                                           9-19
   mode                                                 9-19
   newline                                              9-20
   newline_indent                                       9-20
   next_buffer                                          9-20
   open_line                                            9-21
   page_down                                            9-21
   page_down_next                                       9-21
   page_up                                              9-22
   page_up_next                                         9-22
   put                                                  9-22
   query_replace                                        9-23
   quit                                                 9-23
   quote_character                                      9-24
   re_search_back                                       9-24
   re_search_forward                                    9-24
   read_file                                            9-25
   redraw                                               9-25
   rename_buffer                                        9-26
   rename_file                                          9-26
   repeat                                               9-26
   replace                                              9-27
   report_character                                     9-27
   report_position                                      9-27










   reset_global_mode                                    9-28
   reset_mode                                           9-28
   right                                                9-29
   roll_down                                            9-29
   roll_up                                              9-29
   save_file                                            9-30
   search_back                                          9-30
   search_forward                                       9-30
   set_global_mode                                      9-31
   set_margin                                           9-31
   set_mark                                             9-31
   set_mode                                             9-32
   shrink                                               9-32
   space                                                9-33
   split                                                9-33
   swap_mark                                            9-33
   tab                                                  9-34
   test_key                                             9-34
   top                                                  9-34
   up                                                   9-35
   view_file                                            9-35
   window_down                                          9-36
   window_up                                            9-36
   word_left                                            9-37
   word_right                                           9-37
   write_file                                           9-38
   zap                                                  9-38


APPENDIX A  MESSAGES


APPENDIX B  COMMAND INDEX


APPENDIX C  MNEMONIC INDEX


APPENDIX D  KEY INDEX


APPENDIX E  uEMACS MODE


APPENDIX F  SPECIFICATIONS
   WINDOW LIMIT










   FILE SIZE LIMIT
   BUFFERS PER SESSION LIMIT                            F-1
   HARDWARE REQUIREMENTS FOR SAIL                       F-2


SOFTWARE PROBLEM REPORT


















































HOW THIS MANUAL IS ORGANIZED

     The first thing you should do when you get SAIL is to install it
and run the demo program.  So that you can successfully complete the
tutorial, we suggest that you read through Chapter 1, "INTRODUCTION",
and Chapter 2, "INSTALLING SAIL" right away.  These chapters contain
information that you will need to know so that you can install SAIL.

     If you have already successfully run the demo and have completed
the tutorial, we suggest that you glance over Chapters 1 and 2, and
that you start reading from Chapter 3.  Chapter 3, "STARTING SAIL",
covers the options available to you on the DOS command line.  This
material is not covered in the tutorial.

     Chapters 4, "BASIC EDITING", 5, "THE SCREEN", and 6, "ENTERING
COMMANDS", cover topics in the tutorial and clarify details on commands
that do not fit in the tutorial.

     Chapter 7, "EDITING FACILITIES", goes beyond the scope of the
tutorial, and teaches you how to become an educated user of SAIL.  With
the mastery of the material in this chapter, you will be a skillful
SAIL user, and should be able to increase your productivity by 30% over
your current editor.

     Once you have used SAIL for a while you will be interested in
drawing even more power from it.  For this purpose, Chapter 8,
"ADVANCED TOPICS", was written.

     When you have progressed to this point, put the manual within an
armlength of your computer .  .  .  and refer to Chapter 9, "COMMAND
REFERENCE" on those occasions where you need clarification.  This
chapter, and Appendix A, "MESSAGES", contains all the information you
need to solve your everyday questions about SAIL.

     Users who will be writing commands for use in executable files or
buffers will find the information in Appendix B, "COMMAND INDEX",
Appendix C, "MNEMONIC INDEX", and Appendix D, "KEY INDEX" useful.

     There is also an EMACS mode for users of minicomputers, and for
people familiar with uEMACS.  The key assignments in this mode are
covered in Appendix E, "EMACS MODE".  Although provided in this
version, note that Software Creations does not recommend EMACS mode.

     Appendix F, "SOFTWARE SPECIFICATIONS", covers the design
specifications for the current version of SAIL.





                                                                    i-13





ADDITIONAL INFORMATION

In addition to the material presented in this document, we also
recommend that you be familiar with the following references:


     - Your DOS Manual
     - Your Computer's Hardware Manual




SAIL COMMAND ABBREVIATIONS

To save space and avoid repetition, this manual uses the following
abbreviations for the keys used to evoke SAIL commands.


     Abbreviation  |  Meaning
     ----------------------------------------------------------------
     Esc-          |  Enter Escape, followed by a letter.
     Alt-          |  Shift down the Alt key and type a letter.
     ^             |  Shift down the Control key and type a letter.
     ^X            |  Enter Control-X, followed by a letter.
     F1            |  Press a function key.

























i-14





NOTATION

The following notation is used throughout this manual in command syntax
descriptions:


Square brackets [ ]

Square brackets indicate optional entries.


Angle brackets < >

Angle brackets indicate the type of text that you supply.  Type in an
the type of entry indicated.  For example, <filename>.  When used on a
DOS command line, angle brackets indicate redirection.


Braces { }

Braces indicate a choice between two or more entries.  Choose at least
one of the entries enclosed in braces, unless the entries themselves
are also enclosed in square brackets.


Ellipses ...

Ellipses indicate that an entry may be repeated.


Vertical bar |

A vertical bar indicates an OR statement in a command.  It is usually
used within braces to separate choices.  When used on a DOS command
line, a vertical bar indicates a pipe.


mnemonic_command

Lowercase letters with hyphens indicate statements or commands in the
BREEZE macro language that must be entered exactly as shown.


Initial Capitals






                                                                    i-15





Initial Capitals indicate keys, such as Tab or Return.



All other punctuation marks, such as commas, colons, slashes, and
equals signs must be entered exactly as shown.












































i-16







CHAPTER 1  INTRODUCTION

     SAIL is a text editor, a software tool which you can use to create
and modify programs, documents, and other text files.  Because of its
power, SAIL is a program that you need if you do LOTS of text
processing -- be it electronic publishing, program development, etc.

     On typical computer systems, the text editor is the primary
interface to the computer -- accounting for 15% of all commands
executed at the operating system command line -- more than three times
as often as the nearest competing command.  Yet most users can't
imagine how important this primary software tool is:  it sounds like
too much trouble to learn yet another tool.  Not ever having
investigated other avenues, to do their work, they don't know what
they're missing.

     While very powerful, SAIL is also very easy to learn.  Easy-to-use
help screens assist you in finding a command quickly.  Its command
structure is mnemonic and is easy to remember.

     SAIL was based on uEMACS, an editor which was modeled after EMACS,
an editor written by Richard Stallman of MIT for the UNIX (TM)
Operating System.  SAIL's abbreviated command structure, extensive and
excellent help screens, and advanced optimization, makes it a superior
implementation of a text editor of this design family.

     For beginners, learning SAIL as a first text editor, or for
advanced programmers, learning SAIL after experience with other text
editors, SAIL's simplicity, speed, and power, makes it an attractive
way to do editing tasks.

     Considering the hundreds of text editors and word processors
available for the IBM Personal Computer, why choose SAIL over your
current system?  Well here's a list if you want it.  Can your current
system:


     - Edit several files at once?
     - Support the * and ? DOS wildcards?
     - Open several windows?
     - Record and playback macros?
     - Capitalize entire blocks of text?








                                                                     1-1
SAIL EDITING ENVIRONMENT




     Any one of the above features can save you hours of work, and
since SAIL can do all of them, maybe it's the right system for you.

     SAIL allows you to edit several files at once.  SAIL does this by
supporting wildcards -- used like the familiar DIR command of DOS.
Once you specify the file names on the command line, SAIL reads the
files into separate buffers and keeps track of the changes made to each
buffer.

     When you finish editing, with a single instruction, SAIL saves all
your changes to all buffers during the editing session on disk.

     To help you keep track of the different editing buffers and
manipulate the text within them easily, you can split the screen into
several windows, and move text between buffers.  SAIL even has a buffer
directory command so that you can remember the buffers you are
handling.

     While programmers will find SAIL just the tool they need for
program development, SAIL was also designed for word processing.  It
includes features such as paragraph reformatting, automatic word
wrapping, and case conversion.

     A key concept which pervades the SAIL editing philosophy is the
minimization of repetition.  To do this, SAIL allows you to record
sequences of keystrokes and play them back later.  SAIL also provides
the ability to prefix commands with numeric arguments.  When used in
combination, key recording and numeric arguments can save you hours of
typing.  To speed up predictable repetitive editing tasks, SAIL has an
embedded macro language (BREEZE) which you can use to write your own
editing scripts.  This allows you to customize SAIL commands for your
specific needs.

     Learning a new software package is like learning to drive a new
car -- it may take some time to get used to the new command structure
before it becomes natural.  But once you learn to function with it,
it's an exhilarating experience.

     Perhaps the only way to learn something new is just to do it ...
as a new experience, the only way to learn it SAIL is with direct
experience.  So take the plunge and experiment with SAIL, and follow
along with your computer with this manual as your guide.  Have fun ...








1-2
                                                            INTRODUCTION




Genealogy of SAIL

     The design of SAIL is based on the EMACS family of text editors
written for DEC computers by Richard Stallman of the AI Laboratories of
the Massachusetts Institute of Technology.  Stallman's generosity in
making the source code for the EMACS editor written in the C
programming language spawned a whole range of EMACS-like editors for
any computer that supported a C compiler.

     MicroEMACS was originated by Dave Conroy in 1985.  This code was
then passed on for modification to Steve Wilhite and George Jones.
Daniel Lawrence then made extensive improvements and made it available
as a public domain program distributed by the C User's Group of
McPherson, Kansas.  This editor has reportedly been incorporated into
many professional products.

     In November 1986, Software Creations, as active contributors to
The C User's Group, made a study of uEMACS Version 3.61, and saw that
it had the potential to be developed into a really great editor.
Development since then been proceeding independently for more than a
year, and has also incorporated enhancements up to uEMACS Version 3.9
courtesy of Daniel Lawrence.

     SAIL has also been influenced by ideas in other text editors:
JOVE, Jonathan's Own Version of Emacs, written by Jonathan Payne at
Lincoln-Sudbury Regional High School and modified by Ken Mitchum of the
University of Pittsburgh;  e, by G.  Nigel Gilbert, which spawned QED
by James W.  Haefner, and GED by Mel Tearle;  and Ed Ream's text
editor.  The availability of a rich collection of ideas demonstrates
the strength and depth of the code that has been made available for
public scrutiny.

     There are many editors similar to EMACS.  Brief and Epsilon are
perhaps the two most heavily-advertised EMACS-design editors.  They are
probably much better editors than SAIL.  However, they are also very
expensive, and they are not shareware.

     EMACS is in general a powerful system.  Coded in a way so as to be
portable over many operating systems and machines, it is most useful to
systems programmers who must install new software that will run on many
systems and need the same interface over all of them.  In general, it
is for advanced users, tends to be cryptic, and because many of its
implementations have typically little or no documentation, you have to
have an advanced user friend who has EMACS experience to learn how to
use it.





                                                                     1-3
SAIL EDITING ENVIRONMENT




     Software Creations, having recognized that there is a need for a
powerful editor that can be used by 'the rest of us', saw that a system
that merged EMACS technology with the newer personal computer-style
interfaces would be a good productivity tool.  SAIL thus represents an
attempt to improve the EMACS design by providing fast help screens and
a more user-friendly interface to make it more approachable for the
many of us who haven't worked on minicomputers.  It also features
advanced optimization for the IBM-PC family of computers.

     The SAIL documentation represents to us the clearest information
about an editor of this design family.  This documentation was written
by a professional technical writer.

     This manual was written for SAIL Version 2.00, and is accurate as
of December, 1987.  For brevity, in the rest of this document, the
phrase "SAIL Version 2.00" has been simplified to "SAIL".  Software
Creations expects to distribute enhanced versions of SAIL in the
future;  causing the information in this manual to be superceded by
those improvements.  Notification of new features in your version not
covered in this manual may be found in a text file on your distribution
disk.





























1-4







CHAPTER 2  INSTALLING SAIL



DISTRIBUTION DISK FILES

     The following files should have been included on your SAIL
distribution disk when you received your software package.  Please
contact Software Creations if this is not true for your distribution
package.  Be sure to include the SAIL version number and the name and
address of your distribution source.



Bootstrap

     AUTOEXEC.BAT      Calls GO.BAT
     GO.BAT            Type GO to start


Program

     SAIL.EXE          SAIL Official release.
     SAILHELP.EXE      SAIL Help Screens (Call from within SAIL with F1)
     BOOTSAIL.BAT      Loads SAIL.EXE onto a RAM disk for fast
                       execution.  Rename this file as SAIL.BAT.


Documentation

     ISBN              SAIL's International Standard Book Number
     ANNOUNCE.DOC      New version announcements
     COMMAND.DOC       Command list
     COMMLINE.DOC      SAIL command line syntax and options
     DISKFILE.DOC      Distribution disk file list
     HARDWARE.DOC      Hardware requirements for SAIL
     INSTALL.DOC       How to install SAIL
     MESSAGES.DOC      Messages and their meanings
     READ_ME.DOC       A message for you, called by GO.BAT
     PROBLEM.FRM       Software Problem Report Form
     REGISTER.FRM      SAIL Registration Form


Configuration

     COLOR.SET         SAIL color configuration file




                                                                     2-1
SAIL EDITING ENVIRONMENT




     SAIL.SET          SAIL autostart configuration file


Tutorial

     GO1.BAT           Starts SAIL tutorial 1.
     GO2.BAT           Starts SAIL tutorial 2.
     TUTOR1.TUT        Tutorial 1.
     TUTOR2.TUT        Tutorial 2.


Demonstration

     DEMO.BAT          Starts demonstration program
     SLEEP.EXE         DOS utility to pause for n seconds (for Demo)
     C01.D##           Demonstration program
     C02.D##                       ' '
     C03.D##                       ' '
     C04.D##                       ' '
     C05.D##                       ' '
     C06.D##                       ' '
     C07.D##                       ' '
     C08.D##                       ' '
     DOSCOMMD.DEM                  ' '
     FILEONE.DEM                   ' '
     FILETWO.DEM                   ' '
     FINAL.DEM                     ' '
     HELPDEMO.DEM                  ' '
     KEYMACRO.DEM                  ' '
     OTHERFIL.DEM                  ' '
     REPLACE.DEM                   ' '
     SAILDEMO.DEM                  ' '
     WINDOWS.DEM                   ' '
     WORKFILE.DEM                  ' '



EXECUTION ENVIRONMENT

     When running SAIL from a hard disk, or from a floppy disk divided
into subdirectories, you must set the execution environment so that (1)
SAIL can be run from any subdirectory of that disk and (2) so that SAIL
can find its help, startup, and color files.  The following section
gives you background information.  Read this section, and select one of
the installation procedures according to your disk type.





2-2
                                                         INSTALLING SAIL




     Before you proceed, it is a good idea to read about the PATH
command in your DOS manual, and to be clear on the SET command and how
it can be used to specify environment variables.  These concepts should
have been clearly explained in the manufacturer's manual which
accompanied your computer system;  if not, there are dozens of books on
these subjects at your local library or bookstore.


1.  The PATH must be defined so that SAIL can be executed in any
    subdirectory.

     Explanation:  When DOS looks for a command and can't find it in
the current subdirectory, it starts to look along all paths defined in
its PATH environment variable.  This affects running the SAIL main
module (SAIL.EXE) and its help file (SAILHELP.EXE), because, if you
execute them and they are not in the current directory, DOS has to know
where to find them.

     Assuming that SAIL.EXE will be in the \SAIL directory on drive C,
add the following line to your AUTOEXEC.BAT file.


     set PATH=c:\sail


     If you already have a path defined, add the following to your PATH
command.


     ;c:\sail


2.  Define the SAIL home directory.

     Explanation:  SAIL also provides you with a special 'PORT'
environment variable, used like the DOS PATH environment variable, to
store your information files.  These information files, SAIL.SET, for
the configuration record;  and COLOR.SET, for the color information;
must reside in the directory specified in the 'PORT' environment
variable.

     Assuming that the SAIL help file, SAILHELP.EXE;  the autostart
record, SAIL.SET;  and the color installation information, COLOR.SET;
will be in the \HONOLULU directory, add the following line to your
AUTOEXEC.BAT file.





                                                                     2-3
SAIL EDITING ENVIRONMENT




     set PORT=\HONOLULU




TWO-DRIVE INSTALLATION

     The following procedure is a suggested method for installing
SAIL.  There are many ways to accomplish this task;  this is the method
we use.


1.  FORMAT a new disk and copy the system files to it.

     - Place your system disk in drive A, and a blank disk in drive B.
     - Enter the following command sequence:

          a:
          format b:/s

     - Follow the prompts for the DOS FORMAT program.

2.  Copy all the files on the SAIL disk to the new disk.

     - Place the SAIL disk in drive A.
     - Enter the following command:

          copy a:*.* b:

     SAIL is now configured as a bootable disk.

3.  Reset your computer to test your installation.

     - Put the new disk in drive A, and enter Ctrl-Alt-Delete.


     Note that whenever you make changes to any .SYS files on your
bootable disk, you must restart with that disk to have the changes be
in effect when running SAIL.



ONE-DRIVE INSTALLATION

     Improvise a procedure using the above as a guide.





2-4
                                                         INSTALLING SAIL




HARD DISK INSTALLATION

     If you have a hard disk that is self-starting (it boots itself
without the use of a master floppy), follow the procedure below,
otherwise, improvise a procedure based on the instructions for
Two-Drive Installation.

1.  Make a new directory for SAIL, and copy all files on this disk to
    it.  (For hard disk at drive C, and floppy in drive A)

         c:
         md \sail
         cd \sail
         copy a:*.*

2.  Set the execution environment.

     - Change the environment setting.  Edit your AUTOEXEC.BAT file
       and add the following line to it:

         set PORT=c:\sail

     - Define or modify the PATH variable so that SAIL can be
       executed in any subdirectory.  Add this if no PATH is defined:

         set PATH=c:\sail

              OR

         Add this to the PATH if a path is already defined:

         ;c:\sail

3.  Reset your computer so that DOS will use the new parameters.



TESTING YOUR INSTALLATION

     Installation is seldom a problem from hard disks, because in orher
to run most other applications, you will have already configured the
disk for other applications, and SAIL's running configuration is
similar to typical DOS applications.  From floppy disks, the simplest
solution is to make sure that your SAIL disk is bootable, and always
boot from that disk.





                                                                     2-5
SAIL EDITING ENVIRONMENT




     When you have SAIL configured properly, it should be able to:


     1.  Use the SAIL.SET configuration file.

     2.  Find the COLOR.SET file on a color system.

     3.  Find the DOS command interpreter, COMMAND.COM, on
         your floppy disk (or hard disk) in order to process
         its help, dos_command, and dos_shell commands.


     The following procedure will confirm if you have properly
installed SAIL.


     1.  Boot your system with the new SAIL configuration.

     2.  Type the following command followed by Return.

              SAIL

     3.  Did SAIL flash a message that the margin was set to 72?

              If no, it couldn't find SAIL.SET.

     4.  On a color system, did SAIL say that there was no COLOR.SET file?

              If yes, it couldn't find COLOR.SET.

     5.  Enter the help command (F1).  Did the help screen appear?

              If no, it couldn't find DOS COMMAND.COM, or your
              system has less than 384 K, or you have too many
              RAM-resident utilities.

     6.  Exit from the help screen (End).

     7.  Exit from SAIL (Alt-Q).











2-6







CHAPTER 3  STARTING SAIL

     SAIL can be started without a file name, or with one or more file
names.  SAIL also provides wildcards, like the DOS DIR command, to edit
a group of files.  In addition, SAIL can be given command line options
to change its editing behavior.  This chapter will discuss the various
methods to start SAIL.



STARTING WITHOUT A FILE NAME

     The simplest way to start editing is to enter the SAIL command on
the DOS command line.


     SAIL


     Note that DOS is case-insensitive;  that is, you can type command
names in uppercase or lowercase, or even in mixed case, with the same
results.

     To send the command to the DOS command interpreter so that the
computer can process it, you must press the Return key at the end of a
command line.  This is a convention, and thus for the rest of this
manual, we will omit discussion of the necessity to press the Return
key.

     When the above command is entered, SAIL is loaded into memory from
disk.  Upon execution, SAIL waits for you to enter text or a command.



STARTING WITH A FILE NAME

     If you know the name of the file that you want to edit, it is
easier to start SAIL with a file name.  For example, if you wish to
edit the file named ORANGES, enter the following command.


     SAIL ORANGES








                                                                     3-1
SAIL EDITING ENVIRONMENT




     When the above command is entered, SAIL is executed and loads the
file named ORANGES into the current buffer, displays the first 23 lines
of the file, then waits with the cursor at the beginning of the buffer
for you to enter text or a command.  If the file name provided is a new
file, the text window will be empty and SAIL will display a [New file]
message on the message line.



STARTING WITH TWO OR MORE FILE NAMES

     To make it easy to edit more than one file, you can specify more
than one file name on the command line.  For example, to edit the two
files named FILEONE.TXT and FILETWO.TXT, enter the following command.


     SAIL FILEONE.TXT FILETWO.TXT


     When more than one file name is provided on the command line, SAIL
treats each as a file to be read, and reads them into different
buffers.

     A buffer is a special section of memory that SAIL allocates to
keep track of text.  SAIL creates a separate buffer for every file that
you specify on the command line.  SAIL keeps track of the text from the
file and all changes that you made to it in this buffer.  The concept
of buffers will be discussed at length later in this manual;  for the
moment, bear in mind that SAIL can handle many files at once.

     When many files are specified on the command line, SAIL reads the
first file given, displays its first 23 lines, and waits for you to
enter text or a command with the cursor at the top of the buffer.

     In general, you can use any combination of filenames and pathnames
on the command line.  Note, however, that because SAIL keeps track of
its buffers by the names resulting from truncation of the pathnames
specified, that the ultimate file names must be unique for SAIL to
handle them properly.  For example, the following command line will not
work as you would expect because the filenames, derived from the
pathnames, are the same.


     SAIL ORANGE FRUITS\ORANGE






3-2
                                                           STARTING SAIL




     In the above command line, the operator intended to edit two files
named ORANGE, one in the current directory (ORANGE), and one in the
FRUITS directory (FRUITS\ORANGE).  But because SAIL uses the ultimate
filename, ORANGE, for both text buffers, the names will conflict and
the result will most likely that SAIL (and perhaps even you) will
become confused by the name similarity, and will tend to ignore the
second buffer.  There are ways around this conflict that will become
clear to you after you work with SAIL for a while.  For now, just
remember to keep the filenames unique and the buffer names will also be
in order.

     The rationale for deriving buffer names by truncation will become
apparent after you become familiar with SAIL and learn its buffer
handling mechanism.



COMMAND LINE WILDCARDS

     SAIL accepts DOS wildcards (asterisks '*', and question marks '?')
as can be used in the DIR command of DOS.  These special characters
give you greater flexibility when specifying filenames.



? Wild Card

     A question mark (?) in a filename or filename extension indicates
that any character can occupy that position.  For example, the
following DOS command will cause SAIL to edit all files that begin with
SAIL, have any next character, and have a filename extension of .TXT.


     SAIL SAIL?.TXT


     The following files are typical of those that would match the
above SAIL command:


     SAIL1.TXT
     SAIL2.TXT








                                                                     3-3
SAIL EDITING ENVIRONMENT




* Wild Card

     An asterisk (*) in a filename or filename extension indicates that
any character can occupy that, or any of the remaining, positions in
the filename or extension.  For example, if SAILONE.TXT and SAILTWO.TXT
are the only files in your directory, you could abbreviate the command
as follows.


     SAIL SAIL???.*

         OR

     SAIL SAIL*.*


     The wild card designation *.* refers to all files in the current
directory.  By starting SAIL with wild cards on the command line you
can edit your text files even if you do not remember all of their
filenames.

     SAIL expands the command line wildcards and edits all the
filenames that result from expansion.  When wildcards are expanded, if
the result does not match an existing file, SAIL will begin editing,
but the asterisk or question mark will appear in the file and/or buffer
name on the status line.  Since DOS will not allow you to save or write
a file with a name containing a wildcard character, the best solution
is to exit SAIL and start again with a correct command line.

     Note also that since the current version of SAIL does not check
the file attributes of the input filenames, you can legally specify the
name of a subdirectory as the name of the file you wish to edit.  SAIL
will accept that as a legal filename of an existing file;  however,
since DOS will not allow the file name conflict, you won't be able to
use that file name when saving.  This may occur if you enter '*.*' or
even '*.' as your wildcard filename, as some of the 'matches' may be
directory names.



COMMAND LINE OPTIONS

     SAIL was programmed with a number of command line options.
Command line options are switches given on the command line to change
the editing behavior by entering forward slashes (/), followed by
letters or numbers.  Review this section to find out how you can use




3-4
                                                           STARTING SAIL




these options to your advantage in your editing tasks.  Note that you
can also use hyphens (-) instead of forward slashes.  This makes it
convenient for SAIL users who also do work on minicomputers.



EMACS EMULATION MODE

     For users familiar with the EMACS editor under UNIX, the /E
command line option makes SAIL emulate EMACS key assignments.  For
example, to start SAIL and emulate EMACS, enter a command line as
follows.


     SAIL /E <filenames>


     For the key assignments in EMACS mode, see Appendix D.  Note that
the help screens apply only to SAIL native mode, and that Software
Creations does not recommend EMACS mode.



DISPLAY SPEED

     Due to a bus arbitration conflict on Color Graphic Adapters (CGAs)
that comply totally with the original IBM-PC design, 'snow' will
sometimes appear in programs that write directly to the screen.  SAIL
uses a incorporates a special device driver to eliminate 'snow' during
screen update.  This routine will slow the display speed slightly.

     On newer IBM computers, such as the PC-AT and the PS/2, and on
many clones, this bus arbitration conflict has been resolved.  If your
hardware supports 'snowfree' operation, the /S command line option
allows you to bypass (turn OFF) the delay used in drawing the output
screen, resulting in an increase in output speed.  For best
performance, choose the maximum speed that your hardware will support.

     For example, to start SAIL with high-speed display output, enter a
command line as follows.


     SAIL /S <filenames>







                                                                     3-5
SAIL EDITING ENVIRONMENT




     Note that SAIL automatically senses the presence of a monochrome
adapter, which does not need a delay to combat 'snow', and thus this
command line option is ignored when using SAIL on monochrome systems.



VIEWING FILES

     SAIL allows you to view files without editing them.  The /V
command line option provides a method for reading files without
changing them while taking advantage of SAIL's familiar command
structure.  For example, to view all files with the .DOC extension in
the current directory, enter the following command.


     SAIL /V *.DOC


     When we use SAIL for viewing files, we like to use the following
one-line batch file, named VIEW.BAT, and use it as if it were a DOS
VIEW command.


     SAIL -V %1 %2 %3 %4 %5 %6 %7 %8 %9  (Contents of VIEW.BAT)

     VIEW *.DOC                          (Calls SAIL in VIEW mode)




VERSION NUMBER

     For version control, SAIL has a version command line option
(/VER), which displays SAIL's version number and official distribution
date.  This is the simplest way to verify the version of SAIL you are
running, for communications with Software Creations about possible
questions about your software.


     SAIL /VER


     Note that if you specify the /VER command line option, all other
options are ignored.  Please note that Software Creations may not
support this option in the future.





3-6
                                                           STARTING SAIL




COMMAND LINE HELP

     To explain the many command line options, SAIL also provides help
on the command line.  The /HELP command line option displays the help
information in a command line as follows.


     SAIL /HELP


     Note that if you specify the /HELP command line option, all other
options are ignored.



COMBINING COMMAND LINE OPTIONS

     Command line options, with the exception of /HELP and /VER, may be
combined in any manner.  For example, to view all files with the .DOC
extension in the current directory, and to enable the high-speed
display output, enter a command line as follows.


     SAIL /V /S *.DOC




AUTOMATING COMMAND LINE OPTIONS

     Since it is tedious to have to retype the same options every time
you use SAIL, we recommend that you place the command line options in a
batch (.BAT) file.  For example, if you are always going to use the /S
command line option, create a batch file (named EDITOR.BAT) containing
the following command line:


     SAIL /S %1 %2 %3 %4 %5 %6 %7 %8 %9


     Now if you enter EDITOR instead to call the editor, SAIL will
always be called with the /S option, for example:


     EDITOR *.DOC





                                                                     3-7
SAIL EDITING ENVIRONMENT




     The file named BOOTSAIL.BAT provided on the SAIL distribution disk
shows one way to automate the command line options.  If you use
BOOTSAIL.BAT, use BOOTSAIL instead of SAIL on the command line, and set
your command line option in the line that executes SAIL from RAM disk
in that file:


     D:SAIL %1 %2 %3 %4 %5 %6 %7 %8 %9                 (In BOOTSAIL.BAT)

           ^
          Here




CHANGING THE TEXT COLORS

     SAIL supports both monochome and color text.  SAIL detects if you
have a Color Graphics Adapter (CGA) and allows you to change the text
colors if it is present.  Our experience with CGA cards has shown us
that the CGA is best with black on yellow for most of the screen,
complemented by white on red (or blue) for highlighting.  This is the
color scheme that we like, in addition to white on black.

     There is great variance, however, in the colors put out by display
monitors, and what seems to be an excellent choice to us may not be
true for your color monitor.  Another consideration is that many users
want to coordinate their editor's color scheme with their existing
system software.



Color Installation Menu

     SAIL makes it easy to change the screen colors to fit your needs.
To change the colors on the screen, simply press F2.

     When you press F2, a menu will appear, with two fields:  (1) the
Text and messages field, and (2) the Status line field.  For either
field, you can set either the foreground or background colors.

     The first (Text and messages) field will be highlighted, meaning
that SAIL is ready to receive instructions to change the colors of the
Text and messages field.






3-8
                                                           STARTING SAIL




Changing foreground and background

     To change the foreground color, press the Left or Right cursor
keys.  Foreground colors can take a value from 0 to F (0 to 15 in
Hexadecimal).

     Foreground colors greater than 7 have the intensity bit set, and
thus appear to be brighter.

     To change the background color, press the Up or Down cursor keys.
Background colors can take a value from 0 to 7.  Background colors
greater than 7 will set the blinking bit, causing the characters to
blink, and are thus ignored.



Moving to the next field

     To move to the next (Status line) field, press the PgUp or PgDn
cursor keys.  SAIL will be ready to receive instructions to change the
colors of the status line.



Saving the color settings

     When you have set the colors that you want, enter Alt-S to save
the color settings.  The color settings are saved in the file named
COLOR.SET.  Note that if you do not save the color settings, SAIL uses
the settings that were in the COLOR.SET file before you changed the
screen colors, whenever you start another session.



Exiting color installation

     To return to editing, enter the End key.













                                                                     3-9







CHAPTER 4  BASIC EDITING



INSERTING TEXT

     Once you call SAIL from DOS, you can add text to your file
immediately.

     Inserting text is simple.  Just type any letter, number,
punctuation mark, or symbol.  As you type characters, SAIL inserts the
characters into the buffer.  For example, type the following sentence
fragment:


          The process of preparing programs for


     While entering text, if you make typing errors, use the editing
keys to make simple corrections:  press Backspace to delete the
character you just typed, and press Delete to delete the character at
the cursor.  This capability illustrates the beauty of using a computer
system:  you don't need to stop and white-out your errors, as nothing
is printed on paper yet.

     As you type, SAIL displays the text that you type on the screen.
Now continue typing the sentence as follows:


          a digital computer is especially attractive, not
          only because it can be economically and
          scientifically rewarding, but also because it can
          be an aesthetic experience much like composing
          poetry or music.  -- Donald Knuth


     Finally, press Return twice to start a new paragraph.  What
happens as you finish the second sentence depends on whether Wrap mode
is on or not.



About modes

     When Wrap mode is on, when you reach the right edge of the screen,
if SAIL finds a word (such as 'attractive') that will be too long to




                                                                     4-1
SAIL EDITING ENVIRONMENT




fit on one line, it shifts that word to the beginning of the next
line.

     On the other hand, if Wrap mode is off, the text to the left of
the cursor is shifted to the left, and a '<' sign appears in column
one.

     This simple example illustrates SAIL's flexibility:  when you need
word processing features, simply set Wrap mode on;  when you need
programming features, simply set Wrap mode off.

     You can tell if SAIL is in Wrap mode by looking at the status
line.  If the status line has a capital W in the mode line, Wrap mode
is on.  If no W appears in the status line, Wrap mode is off.  There
are many other buffer settings that you can use, and they will be
discussed in depth later in this manual.



COMMANDS

     SAIL is ready to accept commands anytime during an editing
session.  Nearly everything that you do in SAIL is done by a command.
Even typing text into the buffer is considered to be done by commands,
namely commands to insert characters.

     It so happens that the command to insert the letter 'A' into the
buffer is called by typing the letter 'A'.  In fact, all visible
characters in SAIL are self-inserting -- just type the character to
insert it.

     In addition to inserting text, SAIL has more than 100 commands to
manipulate or edit text.  In SAIL, non-printing characters (such as
control or escape sequences) are used to evoke editing commands.
Commands alter the text in the buffer, or are even used to change the
actions of SAIL itself.  For the rest of this manual, we will take the
word 'command' to mean a key sequence to evoke a non-printing editing
command.

     As an introduction to SAIL commands, we will discuss how to
position the cursor.  In editing, these are the most frequently-used
commands.








4-2
                                                           BASIC EDITING




THE CURSOR

     The cursor is the flashing bar on the screen that shows where the
next character is going to be inserted.  This is also known as the
insertion point.  As you type, SAIL inserts the characters, and moves
the cursor to the right, so that it stays ahead of the inserted
characters.

     When the cursor is moved the insertion point is moved within the
text buffer.  The keys that move the cursor are called cursor keys.
They are located on the numeric keypad.  On most IBM-PC-compatible
systems, for the cursor keys to work, the NumLock lamp must be off.



CURSOR KEYS

Moving by Characters

     To move the cursor right, left, up, and down, use the Right, Left,
Up, and Down arrow keys.  Whenever the cursor is at the end of a line,
and you enter the Up or Down keys, it seeks the rightmost column
possible when you enter Up or Down.



Moving by Pages

     To move the cursor up or down by pages (22 lines), enter PgUp or
PgDn.



Moving by Paragraphs

     Two other simple cursor commands to assist us in moving quickly
within the buffer are next-paragraph, which moves the cursor to the
second paragraph, and previous-paragraph, which moves the cursor back
to the previous paragraph.  To move the cursor to the beginning or end
of the current paragraph, enter Home or End.










                                                                     4-3
SAIL EDITING ENVIRONMENT




CONTROL + CURSOR KEYS

Moving by Words

     To move the cursor to the right or left by words, shift down the
Ctrl key and press Right or Left (^Right or ^Left).



Moving to the Start or End of a Line

     The cursor may also be moved quickly to the extreme ends of the
lines.  To move the cursor to the start or to the end of a line, shift
down the Ctrl key and press Up or Down (^Up or ^Down).  Note that these
two commands are supported only if you are using a memory-resident
keyboard enhancer program that can produce the ^Up or ^Down commands,
if not, these commands may be entered by ^A or ^E.



Moving to the Top or Bottom of the Buffer

     To move the cursor to the top of the buffer, shift down the Ctrl
key and enter Home (^Home).  Similarly, to move the cursor to the
bottom of the text buffer, shift down the Ctrl key and enter End
(^End).  These commands take you to the top or bottom of the buffer, no
matter where the cursor is before you enter the command.



Rolling the Screen Up or Down

     To roll the screen up, shift down the Ctrl key and enter PgUp
(^PgUp).  Similarly, to roll the screen down, shift down the Ctrl key
and enter PgDn (^PgDn).

     Practice moving the cursor (in a scratch file) until you are
comfortable with the cursor commands we've explored thus far and can
locate the cursor very quickly at the spot you want to enter text.



DELETING TEXT

     Making it easy to enter text is one thing, but good editors make
it easy to delete text as well.




4-4
                                                           BASIC EDITING




     SAIL provides many many ways to delete text.  You can delete by
characters, by words, by sentences, or by paragraphs.  You can also
delete to the end of the line, or even the blank lines between two
paragraphs.  All of these are accomplished with simple commands.



Deleting characters

     There are two ways to to delete a single characters:  the
delete-left and delete-right commands.  These can be used to delete the
character to the left of the cursor, or the character at the cursor.

     To delete the character to the left of the cursor, enter the
delete-left (Backspace) command.  Each time you press the Backspace
key, SAIL deletes the character to the left of the cursor.  This is
also known as destructive backspace, because it deletes the text
immediately before the cursor position.  This function, by the way, can
also be entered by Control-H (^H).

     To delete the character at the cursor, enter the delete-right
(Delete) command.  Each time you press the Delete key, SAIL deletes the
character at the cursor.

     When characters are deleted, the text following them is shifted to
the left to close up the space.  Note that SAIL, like most other text
editors, uses, but does not display, a character to mark the end of the
line.  If the end-of-line character is deleted, the two lines separated
by the end-of-line character are joined.



Deleting words

     There are two ways to delete single words:  the delete-word-left
and delete-word-right commands.

     To delete the word before the cursor, enter the delete-word-left
(^Backspace) command.  Each time you enter ^Backspace, SAIL deletes the
word to the left of the cursor.

     To delete the word at the cursor, enter the delete-word-right
(^Delete) command.  Each time you enter ^Delete, SAIL deletes the word
at the cursor.  Note that ^Delete is supported only if you are using a
memory-resident keyboard enhancer program.  You can also enter this
command with ^T.




                                                                     4-5
SAIL EDITING ENVIRONMENT




     For the above two commands, a "word" means all characters found
before a space or newline.  For example, the delete-word-right command
deletes all characters, including punctuation marks, etc.;  if the
cursor is at a middle of a word, the delete-word-right command leaves
the characters to the left of the cursor intact.

     As with character delete commands, whenever word delete commands
are used, the text following the deleted area is moved to the left to
close up the space.  In addition, when delete commands are entered on
ends of lines, the two lines separated by the end-of-line character are
joined.



Deleting to the end of the sentence

     To delete all text, starting at the cursor, and continuing to the
end of the line, enter the delete-to-eol (^XY) command.  If the
delete-to-eol command is entered at the end of the line, the end of
line mark is deleted, and the line that follows the cursor is joined to
the end of the current line.



Deleting blank lines

     To delete all blank lines, beginning with the first non-blank line
before the cursor, and continuing to the next non-blank line, enter the
delete-blank-lines (^XD) command.  The effect of this command is to
close up the blank space between paragraphs.

     Note that the space between the two paragraphs must be absolutely
blank (i.e., it cannot include invisible tab or space characters).  If
spaces or tabs are encountered, the command deletes blank lines up to
the point where the space or tab is found.

     The delete-blank-lines command is ignored if it is entered with
the cursor at the text in the middle of a paragraph.



Deleting paragraphs

     To delete paragraphs, enter the delete-paragraph (^Y) command.






4-6
                                                           BASIC EDITING




     If the cursor is anywhere within a paragraph when the
delete-paragraph command is entered, that paragraph is deleted.  If the
cursor is at a blank line before a paragraph, the first paragraph that
follows the cursor is deleted.

     If the cursor is at the end of the buffer, the last paragraph in
the buffer is deleted.



NUMERIC ARGUMENTS

     To minimize your typing, SAIL allows you to precede each command
with a numeric argument.  Most commands can take numeric arguments, and
when they do, the numeric arguments cause the command to be repeated
the specified number of times.  To enter a numeric argument, simply
press Esc, followed by the number;  finally followed by the command.

     For example, suppose that you needed to type 50 hyphens.  With
SAIL, all you have to do is precede one hyphen with Esc-50.  Try this
by entering Esc-50, followed by the hyphen.  Even after months of using
SAIL, it's surprising how fast this repeat ability makes editing.

     Practice using numeric arguments to speed your cursor movements so
that they are natural.  Numeric arguments will be discussed in greater
detail in Chapter 6.



EXITING SAIL

     At this point we suggest you take a short break and give your eyes
a rest.  But before you do so, you must save your work to a file.
Until a buffer is saved to disk, it is not permanently recorded, and it
will be lost if you exit to DOS or turn off your computer's power
switch.  The buffer is simply a temporary storage area for text (known
as RAM or volatile memory).  This memory is fast, but is also forgotten
without continuous electrical power.



Saving your work

     There are three ways to save your buffer in SAIL -- save-file,
write-file, and zap.  We will discuss all three methods later, but for
now, we will save the buffer using the save-file command.




                                                                     4-7
SAIL EDITING ENVIRONMENT




     The save-file command is entered by holding down the Alt-key and
entering S (Alt-S).

     When you enter the save-file command, SAIL prompts you for the
file name.  Enter a file name using the DOS convention (one to eight
characters, an optional period, followed by three optional
characters).  After you type the file name and press Return, SAIL saves
your file and waits for another command.



Quitting to DOS

     Once you've saved your file, you can enter the quit command
(Alt-Q) to return to DOS.

     In most cases you will want to first save your text as above;
however, if you don't want to save your changes, proceed directly to
the quit command to abandon your changes.  As an added protection for
accidental entry of the quit command, if you try to quit without first
saving your buffer, SAIL will warn you of the loss of changes.  Simply
answer 'y' to the warning if you want to exit.

     Because editing is done with buffers, each time you edit, you have
total control over saving your changes to disk.  Once you are certain
of that your buffer is correct, be sure to save them permanently on
disk.  In cases where you want to abandon your changes, you can easily
abort SAIL without affecting the original file.






















4-8







CHAPTER 5  THE SCREEN

     Now that you are a little familiar with some editing, let's
discuss the entire SAIL screen.  SAIL's screen was designed to maximize
the text viewing area, by providing you 23 lines of 80 characters for
editing.  The SAIL screen is made up of windows displaying the (one or
more) buffers being edited, their status lines, and the message line.
When you call SAIL, it shows you a screen such as the following and
waits for your command.


   -------------------------------------------------------------------
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |                                                                 |
   |==  SAIL == W---O == FILENAME.EXT == \TXT\FILENAME.EXT ==========|
   |[New file]                                                       |
   -------------------------------------------------------------------

             SAIL screen showing the one window, a status
                      line, and the message line.



     The following sections will explain the different parts of the
SAIL screen in more detail.



WINDOWS

     Windows are areas on the screen that display the buffers.  Each
window has text from the corresponding buffer and a status line.  When
you start SAIL, it starts with one window.

     Even if more than one window is displayed on the screen, only one
of them will contain the cursor.  This is known as the current window.




                                                                     5-1
SAIL EDITING ENVIRONMENT




     You can divide the current window into two windows, each of which
can be used to display parts of the same buffer, or even different
buffers.  With windows, you can compare parts of the same or different
files, or edit greatly separated parts of large file.

     For example, you may be working with two buffers, comparing them
on a line-by-line basis.  Or you may be using information from one
buffer to do corrections in another.  Or your file may be 500 lines
long and you'd like to see both parts on the same screen.  These cases
are frequently encountered when editing files.

     SAIL's many window-related commands let you easily move the cursor
between the windows, move them around, and select the spot you want to
display.

     You can also copy or move blocks of text between windows.

     SAIL allows a maximum of 12 windows on the screen.  Whenever you
split a window, one of the windows becomes the current window, and the
cursor moves to that window.  Any subsequent editing changes are made
to that window, but if the cursor is at a point where your editing
changes will affect text in other windows, the other windows will also
be updated.



Status lines

     Status lines are always found at the bottom of each window.
Status lines display information such as the buffer name and file name,
and the buffer's editing modes.

     The status line for the current window is a different color than
the status line for other buffers.  In monochrome systems, the status
line is darker than the other status lines.  In color systems, the
status line for the current window is in your selected colors, other
status lines are in reverse video.













5-2
                                                              THE SCREEN




  Edit indicator       Buffer name     File name
    |                       |             |
  ==* SAIL == WCEVO == FILENAME.EXT == \TXT\FILENAME.EXT ============
              |||||
              Modes (W: WRAP  C: CMODE  E: EXACT  V: VIEW  O: OVER)

             SAIL's status lines display buffer information.




Edit indicator

     The first field of the status line contains an asterisk (*) if the
buffer has been changed.  It is otherwise blank.  When you start
editing, the edit indicator is blank, and the first time you enter or
delete text, this indicator is set.  Whenever you write the buffer to a
disk file, this indicator is reset.



Edit modes

     SAIL provides five different editing mode switches to allow you to
customize its editing style to your needs.  These modes can be enabled
for the current buffer only, or globally (for any new buffer as it is
read from disk).  The second field of the status line contains the
current buffer's edit modes.

     If an edit mode is enabled, a capital letter will appear at that
spot on the status line;  otherwise, a hyphen will appear.  The modes
are encoded as follows:


  Mode         Code   Meaning
  -----------  ----   -----------------------------------------------
  Wrap mode      W    Automatic word wrapping
  C mode         C    Automatic indentation for C programs
  Exact          E    Search/replace with exact case matching
  View           V    Buffer cannot be edited, only viewed
  Overstrike     O    Letters entered overstrike existing text









                                                                     5-3
SAIL EDITING ENVIRONMENT




Wrap mode (WRAP)

     In Wrap mode, SAIL automatically inserts carriage returns when
lines reach the right margin, and wraps the last word of the line to
the beginning of the next line.  This is useful when you need to enter
a lot of text, and want SAIL to align the right margin correctly for
you.  All you have to do is to type your text, and SAIL will enter the
newlines for you.

     You can set the right margin with the set_margin command.  This
command will be discussed in the section entitled "ON-SCREEN
FORMATTING" in Chapter 7.



C mode (CMODE)

     C mode is nice if you program in C.

     In C mode, whenever you press Return, in addition to entering a
newline, SAIL takes the indentation from the previous C statement and
inserts spaces up to that point.  This mode is set automatically for
files having a .c or .h extensions.  This is useful for adding
structured programming techniques.

     SAIL keeps a running total of the number of left and right
braces.  Whenever an opening brace ({) is entered, SAIL automatically
indents another tab distance on the line immediately below.  When a
close brace (}) is encountered, SAIL outdents one tab back.  This is
especially useful when using compound statements with the C keywords
if, for, and while.


     main()
     {
        printf("Hello, world!\n");      - SAIL indents for you.
     }                                  -   . . . and recovers.


     Note that the tab distance can be changed by the tab command.  See
the discussion on the tab command in Chapter 7 for more information.

     For assistance in preprocessor directives, SAIL ensures that the
pound mark (#) used in #define and #include directives will always be
placed in column 1, no matter where the cursor was when you entered the
pound mark.  This erases all leading whitespaces for lines beginning




5-4
                                                              THE SCREEN




with pound marks, assuring that the preprocessor directives will be
flush against the left margin.



Exact mode (EXACT)

     In Exact mode, SAIL distinguishes between uppercase and lowercase
for its search and replace commands.  The search and replace commands
will be discussed in Chapter 7.



View mode (VIEW)

     In View mode, SAIL disables any command that will change the
current buffer or the disk file.  If you attempt a correction in View
mode, SAIL will generate a warning.  In addition to the conventional
methods, View mode is set whenever you call SAIL with a command line
that includes the View mode option, -v.



Overstrike mode (OVER)

     In Overstrike mode, the text that you type replaces the text
existing in the buffer.  If Overstrike mode is reset, the text is
inserted at the cursor, and the rest of the line is shifted to
accomodate the new text.  Toggle this mode when correcting tables and
diagrams and other cases when you need to preserve the paragraph
format.



Changing Edit Modes

     As each buffer has its own set of modes, edit modes may be set or
reset for each buffer.  To switch modes assigned to the current buffer,
use the mode command (F10).

     When you enter the mode command (F10), SAIL displays two banks of
switch settings.  The scope refers to whether you will be changing
buffer modes for the current buffer or for global buffers.

     In the mode selection screen, the PgUp/PgDn keys allow you to
switch between scopes.  The Up and Down arrows highlight the mode that




                                                                     5-5
SAIL EDITING ENVIRONMENT




will be affected.


              Scope         Off On   Mode Name
              ---------     --- --   ----------
           o  Current
                                o    C
                                o    Exact
                             o       Overstrike
                             o       View
                                o    Wrap
           o  Global
                                o    C
                             o       Exact
                             o       Overstrike
                                o    View
                                o    Wrap


     In the Off/On field, one of the 10 marks will be highlighted.
This is the mode that can be changed.  With the Up and Down cursor
keys, move the highlight within the scope to the mode that you want to
change.

     With the highlight on the mode that you want to change, simply
switch the mode by entering the Left or Right cursor keys.  Pressing
the Left cursor key turns a mode off, pressing the Right cursor key
turns a mode on.

     When you are complete setting the modes needing change, press the
End key to return to editing.

     In general, modes that you want to change temporarily (for the
current buffer) should be set or reset using the mode command.  Modes
that you want every time you edit are best entered as set_global_mode
and reset_global_mode instructions in the SAIL.SET file.

     Thus, if you always want SAIL to automatically enter carriage
returns when it reaches the right margin, you would add the following
line to your SAIL.SET file.


     set_global_mode "WRAP"







5-6
                                                              THE SCREEN




     After you setup SAIL in this manner, for those situations where
you want to turn Wrap mode off, you can do so temporarily (for the
current buffer only) by using the mode command.  Refer to the section
on "Command Files and Command Buffers" in Chapter 8 for more details on
using the mnemonic names of commands such as set_global_mode and
reset_global_mode.

     Note that global mode settings are used to set the buffer modes
only when SAIL reads the buffer into memory from disk.  Thus, any
set_global_mode or reset_global_mode commands issued after that point
do not change the global modes of buffers currently in memory.  Rather,
they affect the settings of buffers read after those commands are
issued.



Buffer Name

     The third field of the status line contains the buffer name.  In
the example at the beginning of this chapter, the buffer name is
FILENAME.EXT.  The buffer name is derived from the path name that you
specified for the buffer.  If you omitted a path specification, the
buffer name will be the same as the file name.



File Name

     The fourth field of the status line contains the file name
assigned to the buffer, or is blank if no file name is assigned.  Note
that pathnames may also be included in this field.  In the example at
the beginning of this chapter, the file name field contains the path
name \TXT\FILENAME.EXT.  In most cases, the file name and buffer name
will be the same because files entered in the current directory do not
need the pathname.



MESSAGE LINE

     The bottom line of the screen is the message line.  The message
line is where SAIL displays messages such as file information or
errors;  or in some cases is where SAIL prompts you for more input.
For example, when you start editing on a new file, SAIL displays a [New
File] message on this line.





                                                                     5-7







CHAPTER 6  ENTERING COMMANDS



Once you have text in your buffer, you can edit and revise the text.
To edit a document, you must enter commands.

     There are five ways to enter SAIL commands.


     1.  Press a key.
     2.  Shift down the Control key and type a key.
     3.  Shift down the Alt key and type a key.
     4.  Enter the Esc key, followed by another key.
     5.  Enter ^X (Control-X), followed by another key.


     Examples:


     1.  F1 for help; Delete to delete character; space to enter
         a space character.
     2.  ^S to do a search; ^F to repeat a forward search.
     3.  Alt-2 to split the current window; Alt-1 to close all
         other windows.
     4.  Esc-( to begin a key macro; Esc-E to execute a key macro.
     5.  ^XU to place a word in uppercase; ^XL to place a word
         in lowercase.




COMPLETING COMMANDS

     Some commands require additional information before they can be
carried out.  Examples of this are the save_file command, which
requires you to enter a file name;  or the search command, which
requires the words or letters to search for.  Some commands, such as
the replace command, require more than one item of additional
information.

     Completing a command is easy, just type the text.  If you make a
mistake, use Backspace to delete a single character in the response.
To start all over, enter ^U and the entire response so far will be
deleted.





                                                                     6-1
SAIL EDITING ENVIRONMENT




     Command fields may contain proposed responses that you may use
as-is or alter.  If you type a new response, it is used instead of the
proposed response;  if you skip the response, the proposed response is
used.



CANCELLING COMMANDS

     Commands that require additional information may be interrupted by
entering ^C.

     For example, imagine that you have entered Alt-S to enter the
save_file command, and now that SAIL is waiting for additional
information, you changed your mind and you don't want to save the
buffer.  Enter ^C to cancel the save_file command.



NUMERIC ARGUMENTS

     Numeric arguments, which are entered before other commands, cause
the commands that follow them to be repeated the specified number of
times.  There are two ways to enter numeric arguments:  (1) enter Esc,
followed by the number;  and (2) use the repeat prefix.

     The repeat prefix (^V) causes the numeric argument to become 4.
If the repeat prefix is entered twice, the numeric argument becomes
16.  For three times, the numeric argument becomes 64;  and so on, in
multiples of four, up to seven times for a maximum of 16384.



Examples:


     (1) Using Esc followed by a number:


          To go to line 50 in the file, enter Esc-50^G;  in
          other words, press the Esc key, followed by the
          numbers 5 and 0, finally followed by the goto
          command (^G).

          To initial-capitalize the next eight words, enter
          Esc, followed by the number 8, followed by the




6-2
                                                       ENTERING COMMANDS




          capitalize_word command (^XI).

     (2) Using the repeat prefix (^V):


          To go to line 4 in the file, enter ^V^G;  in other
          words, shift down the Ctrl key and type V, followed
          by the goto command (^G).

          To initial-capitalize the next sixteen words, shift
          down the Ctrl key and type V twice, followed by the
          capitalize_word command (^XI).




SAIL'S DEFAULT ASSIGNMENTS

     Every word processor has a command structure, and a lot of thought
went into the design of the command interface.

     First, the key assignments chosen for SAIL commands are
intuitive:  the left cursor key is used to move left, the right cursor
key to move right -- shift down control and hit left or right to move
in units of words.

     Next, quick movement within the text file was given top priority.
Thus, commands that affect the movement of the cursor were given the
shorter key combinations -- searching forward or backward, repeating
searches, all require the shortest command sequences.  This allows you
to move through a file rapidly.

     Finally, we estimated the most frequently used editing commands
and how they related to the number of strokes needed to perform those
commands.  As a general rule, Esc- affects blocks, Alt- affects buffers
and files, and ^X precedes special commands.

     We believe that we have carefully chosen a scheme which you will
like with experience.

     If you require a specific key configuration, you can always modify
SAIL's default key configuration by using macro commands in SAIL.SET.
This will be discussed in detail in Chapter 8.  If you come up with a
good macro, pass it back to us and we'll see if we can include it in
the next version.





                                                                     6-3







CHAPTER 7  EDITING FACILITIES



To increase the power and speed of editing, SAIL provides advanced
editing facilities;  these are buffers, windows, the notepad, and key
macros.



BUFFERS

     When SAIL is used to edit existing files, it reads the files into
buffers.  This section will show you how to work with buffers.

     A buffer is a location in memory where SAIL stores its version of
the original file.  When you make changes during editing, SAIL changes
the buffers, but does not change the original files.  If you make a
change to a buffer, and wish to discard the changes you made, simply
abandon the buffer;  your original disk file will be unchanged.

     If you start without a file name to edit, SAIL creates an empty
buffer, named "Untitled", with no file name associated with it.

     When you finish editing and are satisfied with your changes, write
the buffer to a file.  Writing erases the old version of the file and
creates a new version of the file containing the text that you had in
the current buffer.



Multiple Buffers

     SAIL supports multiple buffers.  This means that more than one
file can be edited at a time, each file with its own buffer.

     When you create a new buffer by the edit-file command or by
specifying a file on the command line, SAIL allocates memory for that
buffer, and derives for it a buffer name based on the file name or path
name.  SAIL also keeps track of the text within the buffer, the
buffer's size, the active and changed flags, the buffer's edit modes,
and the location of the cursor within the buffer.

     By keeping track of all this information, SAIL allows you to move
between buffers, or work on more than one buffer during one editing
session, without the need to continually save the changes.  This is a




                                                                     7-1
SAIL EDITING ENVIRONMENT




convenient feature which allows you to go to a different buffer, edit
it, and return to the place where you left off.

     As SAIL sets the buffer modes independently, switching from one
buffer to another can change the behavior of editing.  For example, one
buffer may be in View mode, which prevents you from making changes,
while another buffer may have View mode off and you may be actively
editing in it.

     It is possible to juggle large projects using word processors that
handle only one file at a time.  However, by using SAIL, with its
sophisticated buffering, and its convenient buffering commands, the
complexity of the editing task of these large projects can be reduced.



Limits

     When you are advanced at using SAIL, you will find the multiple
buffering feature of the editor indispensable, and you may find
yourself routinely manipulating five or six buffers in the computer's
memory.

     The number of buffers that SAIL can handle is only limited by the
free memory in your system.  In our experience of using SAIL for the
last year, we have frequently had 20 buffers or more in memory and SAIL
still kept track of them perfectly -- buffers totalling more than half
a megabyte!



Buffer Directory

     It is sometimes confusing to have many different buffers in
memory.  To assist you in keeping the buffers organized, SAIL has a
buffer directory.  You can display a directory of these buffers by
using the list-buffers (Alt-D) command.  The information presented will
look similar to the next diagram.












7-2
                                                      EDITING FACILITIES




     A C  Modes  Bytes   Buffer name   Filename or pathname
     - -  -----  ------  ------------  --------------------
          W-E--   -- --  Global
     * *  W.E..   21424  SAIL.1        SAIL.1
     * -  W....    3781  SAIL.2        SAIL.2
     - -  ..E..       0  SAIL.3        SAIL.3

The first line in the buffer directory contains a five-letter WCEVO
code, (W=Wrap, C=C, E=Exact, V=View, and O=Over), showing the global
mode settings.  Modes that are on will appear as capital letters, while
modes that are reset will appear as periods.

     The second, and all successive lines, show, in addition to the
buffer mode settings, the name SAIL uses for the buffer, the buffer's
corresponding file name or path name, and the buffer's size in bytes.

     Column one shows the buffer active flag, which is an asterisk (*)
if the buffer has been read, and a hyphen (-) if not.

     Column three shows the buffer changed flag, which is an asterisk
if the buffer has been changed, and a hyphen if not.  This field allows
you to quickly identify the buffers with unsaved changes, so that you
can save them to files before exiting to DOS.

     In the above example, the directory shows that SAIL.1 is the name
of the buffer, and that it has text totalling 21424 bytes.
Furthermore, the Wrap and Exact modes are set for that buffer, and that
buffer has been read into memory and has been modified.  The SAIL.2
buffer is 3781 bytes long, has been read into memory, and has Wrap mode
set.  Finally, a buffer has been allocated for SAIL.3, but it has not
been read into memory yet.


     Note that internally SAIL has a small overhead for every buffer, and
     thus the memory totals serve only as guidelines for its memory
     requirements if you are doing RAM requirement calculations.


     When you are done viewing the directory, the easiest method to
resume editing is to use the close-other-windows command (Alt-1).










                                                                     7-3
SAIL EDITING ENVIRONMENT




Working With Many Buffers:  Next and Use

     After you have more than one buffer in memory and are familiar
with how to get the buffer directory, it is a simple matter to switch
between buffers by using the next-buffer or use-buffer commands.

     As can be displayed by the buffer-directory command, SAIL keeps an
alphabetized list of all the buffers being edited in the current
editing session.  When you enter the next-buffer command, SAIL switches
to the next buffer listed in the buffer directory.  Such a buffer
directory may appear as follows.


     A C  Modes  Bytes   Buffer name   Filename or pathname
     - -  -----  ------  ------------  --------------------
          W-E--   -- --  Global
     * *  W.E..   21424  SAIL.1        SAIL.1
     * -  W....    3781  SAIL.2        SAIL.2
     - -  ..E..       0  SAIL.3        SAIL.3

For example, if the buffer directory showed that you had three buffers,
SAIL.1, SAIL.2, and SAIL.3, and the current buffer is SAIL.2, entering
the next-buffer command will cause SAIL.3 to become the current
buffer.  The buffer directory itself is handled as a buffer, thus, if
you enter the next-buffer command from the buffer directory, SAIL will
switch to the first buffer in the list.

     In this way, SAIL allows you to cycle through the buffers in
memory, stopping to edit whenever you need to.  However, while the
next-buffer command gives you access to more than one buffer, if you
have many buffers to deal with, flipping through a whole series of
buffers to get to the buffer you want is somewhat roundabout.

     For this purpose, the use-buffer (Alt-U) command allows you to
enter the name of the buffer that you wish to edit.  When you enter the
use-buffer command, SAIL prompts you with the following message on the
message line.


     [Use buffer]  Enter buffer name:

At the prompt, enter the buffer name (as opposed to the file or path
name).  The buffer that you designate will become the current buffer
when you press Return.  If the buffer had been edited in the current
session, SAIL switches to that buffer;  however if the buffer does not
exist, a new buffer with that name (and no file name) is created.




7-4
                                                      EDITING FACILITIES




Discarding Buffers

     The delete-buffer (Alt-K) command to discard an unwanted buffer.
When you enter the delete-buffer command, SAIL prompts you with the
following message on the message line.


     [Delete buffer]  Enter buffer name:

At the prompt, enter the buffer name (as opposed to the file name),
followed by Return.  At this point if the buffer had been changed, SAIL
will ask you if it is ok to discard the changes to the buffer, as data
will be lost.  If this message appears and you answer Y, meaning yes,
the buffer will be deleted.  If you enter N, meaning no, or ^C,
interrupt, editing will resume as if the command had not been entered.

     Note that when you enter the delete-buffer command, the buffer you
specify cannot be currently displayed on the screen.  (It must be
'detached' from the screen before SAIL will allow you to delete it).



Renaming Buffers

     The rename-buffer (Alt-B) command is provided to rename a buffer.
Unlike file names, buffer names may only be renamed, not cleared.  When
you enter the rename-buffer command, SAIL prompts you with the
following message on the message line.


     [Rename buffer]  Enter new buffer name:

At the prompt, enter the new buffer name, followed by Return.



WINDOWS

     SAIL uses windows to display the contents of its buffers.  The
windows are always updated instantly to reflect the most recent editing
changes, so it is a "What You See Is What You Get" (WYSIWYG) system.
In many cases, the buffers will contain more text than can be displayed
on the screen at once.  In those cases, the windows show only a portion
of the buffer.  When the cursor moves past the top or bottom of the
window, the window moves ("Up" or "Down") to where the cursor has moved
within the buffer.




                                                                     7-5
SAIL EDITING ENVIRONMENT




     Since there is a limit to the number of characters that can be
shown on one physical line of the screen, SAIL shows lines that are
(logically) too long to fit on the screen by a greater-than sign (>) at
the end of the line.

     If the cursor is within a long line and it moves "off" the screen
horizontally, the line containing the cursor is scrolled to the left
(or right) to keep the cursor visible.  Only the line containing the
cursor is shifted.  If the cursor is on a shifted line, and you move
the cursor to a different line, the scrolled line is automatically
moved back to its unshifted position.



Opening Windows

     To split the current window into two windows, enter the
split-window (Alt-2) command.  When this command is entered, the window
splits into two windows, both containing the text in the current
buffer.  Each window will not only have text, but will have its own
status line.

     One of the two windows will contain the cursor, and will be
active.  This is called the current window.  All commands issued while
in this configuration affect the current buffer in the current window.



Closing Windows

     If you have many windows open simultaneously, you may want to
close some of the windows to get a larger overall picture.  SAIL
provides two ways to close windows.

     One method is to delete the current window, the other is to make
the current window the only window on the screen.

     To delete the current window, enter the delete-window command
(Alt-0).  To close up all other windows on the screen, making the
current window the only one on the screen, enter the
close-other-windows (Alt-1) command.

     When the delete-window (Alt-0) command is entered, the current
window is deleted, and the adjacent window expands to fill the size of
the two windows.





7-6
                                                      EDITING FACILITIES




     The window affected by the delete-window command depends on the
location of the current window on the screen.  For example, if there
are three windows, and the current window is the middle window, the top
window receives the area of the deleted window.  If the current window
is the top window or the bottom window, the middle window receives the
area of the deleted window.

     In contrast to the above, the close-other-windows command resets
the screen to the full-screen edit mode that appears when you start
editing with SAIL.



Resizing Windows

     Once more than one window is on the screen, SAIL allows you to
resize the current window:  enlarging it or shrinking it, for easier
editing.  For example, you may be doing a complicated task and have
opened a number of windows.  In some cases, the window may be too small
to show the entire section you want to work on.

     You can enlarge the current window by entering the enlarge (^U)
command, and shrink the current window by entering the shrink (^D)
command.  For either command, the current window, and the adjacent
window, is resized by one line.

     The adjacent window that will be affected by the enlarge or shrink
commands depends on the location of the current window on the screen.
For example, if there are three windows, and the current window is in
the middle, the bottom window is also resized.  If the current window
is the top window or the bottom window, the middle window is resized.



Moving Between Windows

     The current window is the window containing the cursor, and the
status line for that window is unique.  You can edit in any window on
the screen, and to do this you can move the cursor to another window.

     To move the cursor to the next window (down on the screen), enter
the next-buffer (^XN) command.  To move the cursor to the previous
window (up on the screen), enter the next-buffer (^XP) command.







                                                                     7-7
SAIL EDITING ENVIRONMENT




Paging The Next Window

     As you work with SAIL, you will find that most of its editing
commands affect the current window, and the other windows are ignored;
except when a command affects text that is duplicated in another
window.  While most SAIL commands affect only the current window, two
useful commands allow you to page the next window.

     To page up the next window, enter the page-up-next (^W) command.
To page down the next window, enter the page-down next (^Z) command.



Centering The Cursor

     Once you have text on the screen, to move the cursor to the center
of the window, enter the center-cursor (^P) command.  The center-cursor
command is useful for keeping track of the cursor when jumping from
window to window.  It is also useful when you need to align two buffers
for comparison so that you can easily flip between them to see their
differences, or when you need to edit a section and you want to be
editing on a specific line of the screen.

     When you enter the center-cursor command, it shifts the line
containing the cursor and all the text to the center of the window.

     The center-cursor command also can be given a numeric argument.
If you enter a numeric argument of n, it shifts the cursor so that it
is placed on the nth line of the current window.  Negative numeric
arguments are permitted, and shift the cursor to the nth line from the
bottom of the window.

     For example, if you want to shift the text so that the line
containing the cursor is the 5th line of the current window, enter
Esc-5^P.  On the other hand, if you want to shift the text so that the
line containing the cursor is the 5th line from the bottom of the
current window, enter Esc--5^P.  (The second hyphen is a minus sign for
the numeric argument).



Redrawing The Screen

     To redraw the screen, enter the redraw (^L) command.  Sometimes if
you search for a very long string, the message line will be moved up
and the status line will disappear.  Or you may have executed a DOS




7-8
                                                      EDITING FACILITIES




command that causes spurious characters to appear on the screen.
Simply redraw the screen with ^L.

     Experiment with the windowing commands.  Once you master the
windowing commands, you will be able to use your ability to skillfully
edit large buffers, or many different buffers.



BLOCKS

     Block commands affect an entire text area that you have
predefined, allowing you to handle large chunks of text.  In
conventional word processors, you have to mark the beginning of the
block AND mark the end of the block.

     SAIL instead abbreviates block marking by having you define a
begin-block mark.  Once this mark is set, just move the cursor to the
end of the block, and the block is the area between the begin-block
mark and the cursor.



Marking the block

     To set the begin-block mark, first move the cursor to the start of
the block that you want to define.  Mark the beginning of the block by
using the set-mark command (Esc-Space).  In response, SAIL displays the
following message.


     [Begin-block mark set]

Next move the cursor to the end of the text block.  The block is taken
to be the area between the begin-block mark and the cursor.  Note that
the cursor may be either above or below the begin-block mark.  With the
cursor at the end of the block, you may enter any one of the following
commands.


     delete-block  Esc-Y    Delete block to notepad  (Clears notepad)
     copy-block    Esc-C    Copy block to notepad    (Clears notepad)
     caps-block    Esc-U    Uppercase block
     lower-block   Esc-L    Lowercase block

Note that SAIL keeps track of the latest position of the begin-block




                                                                     7-9
SAIL EDITING ENVIRONMENT




mark only, and forgets any of its previous locations, whenever you
place a new begin-block mark.



Marking a position in the buffer

     In addition to the above block commands, the begin-block mark can
also be used to mark a place in the text where you can return to.


     swap-mark    ^XSpace   Move cursor to begin-block

The swap-mark command moves the cursor to the begin-block mark, using
the cursor position for the new begin-block mark.



NOTEPAD

     When entire blocks are deleted, instead of simply discarding the
text that was in the block, SAIL saves the deleted text in an area of
its memory called the notepad.  The text in the notepad is dynamic, and
always contains the last deletion.

     For example, after you delete a block of text, you decided that
deleting it wasn't a good idea.  Immediately after you delete the block
of text, you can recover it by using the put command.  This provides a
way for you to undo accidents.

     Knowing about the notepad can save you a lot of typing.

     In addition, you can use the notepad to move text between windows
or buffers.  Simply delete from one buffer and place the text in
another buffer.

     To repeat entire sections of text, use the copy-block command.
Instead of deleting the block to the notepad, the copy-block command
copies the block to the notepad.

     The following sections illustrate the notepad concept.









7-10
                                                      EDITING FACILITIES




Deleting Blocks

     The delete block command deletes the text block from the buffer
and places it in the notepad, replacing the text in the notepad.

   Window before command                  Window after command

----------------------------           ----------------------------
|Text in the buffer        |           |Text in the buffer        |
|                          |  Delete   |                          |
|CUT THIS TEXT._           | --------> |_                         |
|                          |  command  |                          |
|Text in the buffer        |           |Text in the buffer        |
----------------------------           ----------------------------

   Notepad before command                 Notepad after command

 --------------------------- (Previous  ---------------------------
 |(Other text)             | ---------> |CUT THIS TEXT.           |
 ---------------------------   text     ---------------------------
                             discarded)




Copying Blocks



The copy block command copies the selected text into the notepad
without deleting it from the buffer, and, as a result, erases the text
that was previously contained in the notepad.


















                                                                    7-11
SAIL EDITING ENVIRONMENT




   Window before command                  Window after command

----------------------------           ----------------------------
|Text in the buffer        |           |Text in the buffer        |
|                          |   Copy    |                          |
|COPY THIS TEXT._          | --------> |COPY THIS TEXT._          |
|                          |  command  |                          |
|Text in the buffer        |           |Text in the buffer        |
----------------------------           ----------------------------

   Notepad before command                 Notepad after command

 --------------------------- (Previous  ---------------------------
 |(Other text)             | ---------> |COPY THIS TEXT.          |
 ---------------------------   text     ---------------------------
                             discarded)




Inserting From The Notepad

     The put command inserts text from the notepad into the buffer in
front of the cursor.  Combine the put command with the delete-block or
copy-block commands to copy and move text around.

   Window before command                  Window after command

----------------------------           ----------------------------
|Text in the buffer        |           |Text in the buffer        |
|                          |    Put    |                          |
|Text_in the buffer        | --------> |TextPUT THIS TEXT. in the |
|                          |  command  |buffer                    |
|                          |           |                          |
----------------------------           ----------------------------

   Notepad before command                 Notepad after command

 --------------------------- (Notepad   ---------------------------
 |PUT THIS TEXT.           | ---------> |PUT THIS TEXT.           |
 ---------------------------   text     ---------------------------
                             retained)








7-12
                                                      EDITING FACILITIES




Notepad Transience

     The notepad is DYNAMIC.  To minimize the memory requirement, each
time you delete a block, line, or word, SAIL empties the notepad before
replacing it with the most recent deletion.

     This means that if you are going to be recovering text from the
notepad, do not delete anything else before you use the put command.
If you delete yet another block, line, or word, you will discover that
the notepad has been cleared and has the most recent deletion.

     Thus when moving large quantities of text, use the put command
BEFORE you do additional deletions to make sure that the block will be
intact.



FILES

     The file commands read and write your buffers to files.

     Buffering maximizes editing speed during editing because memory,
being solid-state, is much faster than the computer's disks, which are
mechanical.  During editing, SAIL works exclusively with high-speed
memory, and disks are only used when text has to be read from or
written to files.

     But high-speed memory is "volatile", i.e., it is forgotten when
you turn the computer off.  Therefore, before you switch off the power,
make sure that you save your buffers to disk files.

     Once your work is saved on disk, it is ok to shut down the
system.  Then when you return to your work one hour or one year later,
your work will still be available.

     It is wise to keep a copy (a backup) of your work and take it
offline, storing it in a safe place -- even two backup copies are not
unreasonable when you do important work.

     When you read a file into memory, SAIL uses its path name (or file
name as the case may be) to derive the name of the buffer.  While it is
possible to change the name of the buffer, because SAIL derives the
buffer names automatically, the buffer names and file names are closely
related.






                                                                    7-13
SAIL EDITING ENVIRONMENT




Reading Files

     There are four commands to read files in SAIL.  They are the
edit-file, read-file, merge-file, and view-file commands.

     The edit-file (Alt-E) command prompts for the name of a file to
edit.  If the name given is the name of an existing buffer, that buffer
is selected;  otherwise, SAIL creates a new buffer, and reads the disk
file's contents, if present, into the buffer.  When the edit-file
command is entered, SAIL prompts you with the following message:


     [Edit file]  Enter file name:


     At the prompt, enter the new file name, followed by Return.  If
the file name given conflicts with the name of a buffer, SAIL asks you
for a new buffer name.


     Enter buffer name:

When you provide a new name, SAIL reads the specified file into the
buffer with the name you specify.  If you don't enter a new name, SAIL
clears the current buffer.

     The read-file (Alt-R) command prompts for the name of a file to
read into (and take the place of) the current buffer.


     [Read file]  Enter file name:


     At the prompt, enter the new file name, followed by Return.

     The read-file command also provides an easy way to discard changes
to the current buffer and restart editing.  For example, if you wish to
start editing again without the changes you have made, simply reread
the original disk file over the current buffer.

     The merge-file (Alt-M) command prompts for the name of a file to
merge.  The contents of the named file are inserted into the current
buffer at the line preceding the cursor, regardless of the cursor's
position in the current line.  After the merge the cursor is placed at
the position following the merged file.





7-14
                                                      EDITING FACILITIES




     The view-file (Alt-V) command prompts for the name of a file to
read in View mode.  View mode allows you to read the contents of the
file without the ability to modify the file.

     Whenever you execute a command that calls for the creation of a
buffer, SAIL derives a buffer name to be associated with that file.
The buffer name arises from the ultimate file name from the full DOS
path specification.  In general, DOS pathnames are as follows:


     [<drive:>][[\][<path>]|<path>][[<path>]\]filename[.extension]

On the other hand, SAIL buffer names can be described as follows:


     filename[.extension]

For this reason, a full DOS path specification of a file such as
C:\HONOLULU\SAIL.SET is truncated to a name of SAIL.SET when SAIL reads
that file into a buffer.  For the most part, this is a very convenient
way to handle buffers, as most operators prefer working with the short
buffer names.

     Due to the above automatic buffer naming, if you edit two files,
the first named C:\HONOLULU\SAIL.SET and the second named
D:\TEMP\SAIL.SET, a buffer naming conflict will arise when you attempt
to read the second file into a buffer, because SAIL will already have
created a buffer named SAIL.SET when it read the first file.

     In that case, to complete the read operation for the second file,
D:\TEMP\SAIL.SET, SAIL will ask you to supply a unique buffer name to
resolve the conflict.  This may be required for the edit-file or
view-file commands.

     Refer to the explanations in your DOS reference manual from your
computer manufacturer for more details on DOS path and file
nomenclature.



Writing Files

     There are four commands to write files in SAIL.  These are the
save-file, write-file, quit, and zap commands.  In addition, there is a
rename-file command.





                                                                    7-15
SAIL EDITING ENVIRONMENT




     The save-file (Alt-S) command prompts for a file name, and writes
the current buffer to that file.  If the file already exists, it is
overwritten.


     [Save file]  Enter file/path name:

The write-file (Alt-W) command writes, without confirmation, the
current buffer to the file associated with the buffer.  If the file
already exists, it is overwritten.

     The quit (Alt-Q) command exits SAIL and goes back to the operating
system.  Since the quit command does not save buffers, it is a way to
discard unwanted changes.  If you enter quit without saving all your
buffers, SAIL prompts you with the following message.


     Abandon unsaved change(s) (y/n)?

When you edit many buffers, you must save each buffer to disk before
you exit SAIL.  The write-file command saves only the current buffer.
Instead of having to circle through your buffers, stopping to write
each buffer, SAIL provides you an easy way to save all your changes at
once.

     When editing multiple buffers, will want to make sure that all of
your changes are saved on disk before you exit to DOS;  furthermore,
you may have not saved each buffer after each change that you made.
For this purpose, the zap (Alt-Z) command performs a write-file on all
unsaved buffers in the current session.  After updating all of the disk
files, SAIL exits to DOS.  Essentially, the zap command is a shortcut
way of executing the write-file command on each of the buffers,
followed by the quit command.

     The rename-file (Alt-F) command changes the name of the file that
SAIL will use for the write-file or zap commands, or, if there was no
file name assigned to the buffer, assigns a file name to the buffer.
It also can be used to erase the file name field for added protection
against accidental erasure.  This is unlike the DOS REN command because
the name on the disk is not affected.

     When you enter the rename-file (Alt-F) command, it displays the
following prompt and waits for your input.


     [Rename file]  Enter new file/path name:




7-16
                                                      EDITING FACILITIES




In response to the prompt, enter a new file or path name.  At this
point, if you press Return without entering a name, the file name field
is cleared.  Assuming that you entered a valid file name or path name
that is acceptable to DOS (a non-blank name that does not duplicate the
name of an existing directory or read-only file, and a path that DOS
can find), the next time you use the zap or write commands, the file
will be saved under the new name.

     Note that when you use the rename-file command, SAIL retains the
buffer name.  SAIL provides a rename-buffer command to rename the
buffer if wanted.



Overwriting

     When you instruct SAIL to write a buffer to a file, if the file
exists on disk, it overwrites the previous version of the file;  and
erases the original file.  During this process, the original version is
erased.  This is like the DOS COPY command -- if the target file you
specified already exists, DOS copies over it, overwriting its
contents.  This brevity is a merit or not, depending on your
viewpoint.

     In addition, when writing to disk, SAIL does not stop to ask you
for permission to overwrite the old file.  Again, this is a merit,
depending on your viewpoint.

     What this means is that when you have important files to edit,
make a copy of them beforehand, using a different disk or a different
subdirectory.  (If they were that important, wouldn't you have done so
anyway?)

     The other method of working with this scheme is to save the file
with a different name if you want to retain the original version of a
file.  To do this, use the save-file command instead of the write-file
command when saving the buffer.  The original file will be intact.



SEARCHING FOR TEXT

     The search commands search the current buffer for the specified
text.  Searching starts at the cursor and goes forward (toward the
buffer's end) or backward (toward the buffer's top).





                                                                    7-17
SAIL EDITING ENVIRONMENT




     The search-forward (^S) command prompts you for a string to search
for, then searches the buffer forward for that string.  When the
search-forward command is entered, SAIL prompts for the text with the
following message:


     Search ()[Esc]:

This is a prompt to enter the search string.  Enter the target string,
followed by the Esc key.  If you make a mistake, use Backspace to
delete a single character in the response, or if you wish to start all
over, you can delete the entire response with ^U.

     If this is the first search of the editing session, the two
parentheses will be together.  After the first search, there may be a
proposed response;  this response will be used if you don't specify a
new string.

     Note that carriage returns (newlines) are taken to be part of the
string to search for, and that if you enter [nl], a "[nl]" sequence
will appear in the search string.  The use of the [Esc] character to
end the search string here allows you to search for carriage return
characters.

     The search-back (^R) command prompts you for a string to search
for, then searches the buffer forward for that string.  It is identical
to the search-forward command;  except that the search direction is
reversed.

     Whenever a search string is found, the cursor moves to the end of
the string that it found.

     Because SAIL searches from the cursor position toward the end of
the buffer, in many cases you will want to precede the search command
with a command to move to the top of the buffer.



Exact mode

     Note that searching is case-sensitive (capitals and lower case
letters are significant) only in Exact mode.  Toggling Exact mode on or
off, you can search for any combination of capitals and lowercase that
you want.






7-18
                                                      EDITING FACILITIES




     Thus, if Exact mode is set, and you enter "ph" for your search
string, SAIL will find words that include the string "ph" in the same
case such as "physical", "telephone", and "staph".

     If Exact mode is reset, SAIL searches and replaces without regard
to case.  Thus, if you enter "ph" for your search string, SAIL will not
only find the above three words, it will also find words or phrases in
uppercase such as "Physical", and "pH balanced", and "PHONE MARKET".



REPEATING SEARCHES

     SAIL keeps its last search string to make it easy to repeat
searches.  The re-search-back and re-search-forward commands can be
used to repeat searching forward or backward without the need to
reenter the search string.

     The re-search-forward (^F) command searches the buffer forward for
the search string used in the previous search or replace command.  The
re-search-back (^B) command is identical to the re-search-forward
command, except that the search is done in the opposite direction.

     Note that these commands need a previously-specified search string
and thus do nothing if there was no previous search or replace command
in the current editing session.



REPLACING TEXT

     Two types of "search and replace" commands are provided to search
the buffer for the specified text and replace it with other text.  One
is done with confirmation and the other is done without confirmation.



Replace

     The replace command (Esc-R) replaces the specified search string
with its replacement string throughout the text in the entire file
without asking for confirmation.  Unconditional replace is powerful and
affects all found search strings with their replacements.







                                                                    7-19
SAIL EDITING ENVIRONMENT




Completing the responses

     After entering a replace command, SAIL requires you to enter two
character strings:  the search string and the replacement string.  The
first prompt is as follows:


     Replace ()[Esc]:

At this prompt, enter the search string, followed by the Esc key.  The
second prompt is as follows:


     with ()[Esc]:

At this prompt, enter the replacement string, followed by the Esc key.

     When you press the [Esc] key the second time, SAIL replaces all
instances of the target string with your replacement.  Note that the
setting of Exact mode affects how SAIL finds the target strings.  Thus,
if you want case-sensitive replace, set Exact mode on;  if you want
SAIL to ignore case when replacing, set Exact mode off.

     For selective replace, there is a query-replace command.



Query-replace

     The query-replace command (Esc-Q) steps through the file, pausing
for you to confirm the change whenever the search string is found.  You
then have the option to enter one of the following keys:  Y, N, ^C, G,
S, H.

          Enter Y, meaning Yes, to replace the search string at
     the cursor with the replacement text, and continue.

          Enter N, meaning No, to skip replacing the search string
     at the cursor, and continue.

          Enter G, meaning Global, to approve for the rest of the
     buffer, without further confirmation.  This is similar to the
     replace command above.

          Enter ^C, meaning Cancel, to abort further processing on
     the query-replace command and leave the cursor at the start




7-20
                                                      EDITING FACILITIES




     of the last search string.  Note that aborting does not
     affect any previously-confirmed changes.

          Enter S, meaning Start, to abort the query-replace
     command and leave the cursor where it was when the command
     was first entered.  As with ^C above, aborting does not
     affect any previous approvals.

          Enter H, meaning Help, to output a help line with the
     above information.

     Note that in either of the above two replace commands, the area
affected is from the cursor to the end of the file.  Thus, if you want
to replace all occurrences in the entire buffer, move the cursor to the
beginning of the buffer first.



ON-SCREEN FORMATTING

     While SAIL is a dedicated text editor, as opposed to a word
processor, it has some formatting options to help you format your
text.  These features include word wrapping, justification, and
case-substitution.



Word Wrapping

     Word wrapping is a feature that "wraps" words at the ends of
lines.  Word wrapping means less keystrokes, because once you reach the
right margin, instead of having to press the Return key, SAIL wraps the
word to the new line for you.  Without word wrapping, you must press
Return at the end of lines.

     If Wrap mode is set, word wrapping is done automatically.  Wrap
mode is usually set in the autostart file (SAIL.SET), but may also be
enabled by the set-mode command.  When Wrap mode is set, the letter W
appears on the first column of the mode field on the status line.



Right Margin

     The right margin determines where lines are to be wrapped.  To
change the right margin, enter a numeric argument, followed by the




                                                                    7-21
SAIL EDITING ENVIRONMENT




set-margin command (^XF).  For example, "Esc-72^XF" sets the right
margin to column 72.

     Note that set-margin needs a numeric argument.  If you do not
precede it with a numeric argument, the margin will be set to 1, and
your text will wrap at every word.

     The right margin is also commonly preset by the use of a
set-margin command within the SAIL.SET file.  In executable files, the
set-margin command takes the form of "72 set-margin".  See the example
in the SAIL.SET file included in your SAIL distribution disk.



Justifying Paragraphs

     Word wrapping works during active editing, and if you change the
margin or do deletions spanning several lines, your buffer may contain
a paragraph that must be reformatted.

     Enter the justify command (Esc-J) to reform a paragraph to fit
within the area between the left edge of the screen and the right
margin.  Note that the justify command may take some time to complete
if the paragraph is very long or if it contains words that are too long
to fit within the margins.



Case Conversions

     SAIL provides three commands for case conversions.  Once you have
entered text, if you are only converting words from uppercase to
lowercase or vice-versa, you don't need to retype the text, because
SAIL can do all the case conversions internally.  Words can be
converted to ALL CAPITALS, Initial Capitals, or lowercase.

     The upper-word command (^XU) places the next word in uppercase.
Similarly, the lower-word command (^XL) places the next word in
lowercase, and the capitalize-word (^XI) command initial capitalizes
the next word.

     Note that in the above three commands, a "word" means all
characters found before a space or newline.  Thus, if a string has
imbedded punctuation marks, the punctuation marks do not signify the
ends of words.  The uppercase-word command, for example, places an
entire string in capitals and not stop at the punctuation marks, etc.,




7-22
                                                      EDITING FACILITIES




embedded in the middle of "words".

     When using the case conversion commands, you would normally
position the cursor at the first letter of the target word;  however,
these commands can also be used with the cursor at the middle of words
for such cases as pH, uEMACS, or Ph.D., which switch cases in the
middle.

     The above commands may be preceded by numeric arguments.  For
large areas, use the caps-block and lower-block commands.



KEY MACROS

     Key macros, or recorded sequences of keystrokes, offer a
convenient method of storing text or commands for later playback.  SAIL
provides you three different key macro commands, which, like three
buttons on a dictation machine -- START, STOP, and PLAY, can be used to
record any sequence of keystrokes.

     For example, if you are using SAIL to write a scientific paper
about the structure of Deoxyribonucleic Acid (DNA), the need to have to
repeat the chemical name of DNA would probably be boring, even to the
most skilled typist or patient geneticist.  SAIL lets you record long
words or groups of words such as Deoxyribonucleic Acid, and lets you
playback the whole twenty-one character string all at once.

     You could accomplish the above by global replace, but there is
another advantage when you use key macros with word wrapping.  If Wrap
mode is on when you use key macros, the paragraphs will be formed
correctly, eliminating the need for manually justifying paragraphs.

     Another neat feature about key macros is that you aren't limited
to text.  Besides text, key macros may contain editing commands.  You
are only limited by your imagination.  Just turn macro record on, do
your repetitive task, and turn macro record off.  Now to repeat it,
just play the key macro back.



Using key macros

     To begin a key macro, enter the begin-macro command (Esc-().  Now
enter the key sequence that you wish to repeat.  Finally, to stop the
key macro, enter the end-macro command (Esc-)).  SAIL stores all keys




                                                                    7-23
SAIL EDITING ENVIRONMENT




typed between those two commands.

     To playback the key macro, simply enter the execute-macro command
(Esc-E).  Each time you enter the execute-macro command, the sequence
of keystrokes that you had entered is played back on the buffer in
memory.  You can repeat this key macro as many times as you want, until
you erase the key macro by defining another key macro.

     One nice feature is that as with many other SAIL commands, you may
give the execute-macro command a numeric argument.  Thus, going to the
top of 10 buffers in memory is simple and requires just the following
keystrokes:


     Keystroke      Command                Meaning
     ---------      ---------------        ---------------------
     Esc-(          (begin-macro)          Begin the macro
       ^Home        (top)                  Go to the top
       Alt-N        (next-buffer)          Go to the next buffer
     Esc-)          (end-macro)            End the macro
     Esc-9          (repeat 9)             Play macro 9 times
     Esc-E          (execute-macro)

Another neat technique is using the search feature within a key macro.
For example, say you were working on the following macroassembler
procedure, and you wanted to capitalize your comments.


     ; Checks to see if there is a character in the key buffer.
     ;
      public _keyhit
     _keyhit proc near
      push bp        ; Entry sequence
      mov bp, sp
      mov ah, 1      ; Check key buffer function
      int 16h        ; Using BIOS
      mov ax, 0      ; Assumes that no character is ready
      jz abort       ; If character ready (zero set), jump out of here
      mov ax, 1      ; Character ready
     abort:
      mov sp, bp     ; Exit sequence
      pop bp
      ret
     _keyhit endp






7-24
                                                      EDITING FACILITIES




     In assembler, comments start with semicolons (;), so to capitalize
all the comments in the above procedure, define the following key
macro:


     Keystroke      Command                Meaning
     ------------   ---------------        ----------------------
     Esc-(          (begin-macro)          Begin the macro
       ^S           (search)               Search
         ;                                 For semicolon
       Esc                                 End search
       Esc-Space    (set-mark)             Define a block
       ^E           (end)                  Go to end of line
       Esc-U        (uppercase-block)      Capitalize block
     Esc-)          (end-macro)            End the macro
     Esc-100        (repeat 100)           Playback many many times
     Esc-E          (execute-macro)

Because the key macro aborts when a search string is not found, you
don't need to count the number of times to execute the command.  In
just a jiffy, the above text is transformed as follows:


     ; CHECKS TO SEE IF THERE IS A CHARACTER IN THE KEY BUFFER.
     ;
      public _keyhit
     _keyhit proc near
      push bp        ; ENTRY SEQUENCE
      mov bp, sp
      mov ah, 1      ; CHECK KEY BUFFER FUNCTION
      int 16h        ; USING BIOS
      mov ax, 0      ; ASSUMES THAT NO CHARACTER IS READY
      jz abort       ; IF CHARACTER READY (ZERO SET), JUMP OUT OF HERE
      mov ax, 1      ; CHARACTER READY
     abort:
      mov sp, bp     ; EXIT SEQUENCE
      pop bp
      ret
     _keyhit endp


     Giving the execute-macro command numeric arguments is very
powerful, and like any other command that will affect a lot of text, of
course it is best to save your buffers before you execute it.






                                                                    7-25
SAIL EDITING ENVIRONMENT




     As SAIL currently supports only one macro, if you start recording
another macro, the previously defined macro is erased.  A macro
programming language, BREEZE, has been provided with SAIL so that you
can define macros, and store them on disk for later use.  This
programming language is used for the autostart file, SAIL.SET.  Read
the next chapter to learn about using this feature.

     SAIL reserves enough memory for 500 keystrokes (6 full lines) in
its key macro memory.  For editing tasks requiring larger buffers, use
the copy and put commands, or the macro programming language.



SETTING TAB STOPS

     SAIL emulates tabs with software and makes them freely adjustable
by filling in the tab distance with spaces.  The default for tab
spacing is four spaces.  The tab stops can be changed by entering a
numeric argument, followed by the tab key.  For example, to change the
tab stops to three spaces, enter the following command.


     Esc-3 [Tab]      Sets Tabs at every 3 spaces


     Since SAIL can read files, and supports substitution strings, that
contain the hard tab character (^I, or ASCII 0x08), the cursor behavior
may seem unpredictable at times.  Rather than being erratic, this
behavior can be understood and is predictable.

     For example, the tab character may precede the first word of a
line, and when the left or right cursor commands are entered, the
cursor may jump around unexpectedly.  This is because SAIL handles text
in units of single characters.


     SOFT TAB
      |   |   |   |   |   |   |   |   |   |   |   |   |   |
       Sp  Sp  Sp  Sp  Sp  Sp  Sp  Sp   F   i   r   s   t
       <--- Actually has 8 spaces --->

     HARD TAB
      |   |   |   |   |   |   |   |   |   |   |   |   |   |
       TAB                              F   i   r   s   t
       <---- Looks like 8 spaces ---->





7-26
                                                      EDITING FACILITIES




In the above example, if the cursor were at the first letter of the
word "First", and you were to press Backspace, and there was a soft
tab, the word "First" would move to the left one space.  On the other
hand, if there was a hard tab, the word "First" would move to the left
margin.  In either case, SAIL deletes a single character, but when a
hard tab is deleted, the text moves back one tab stop, in this case, 8
spaces.

     If you want to enter a hard tab, you can do so by entering a
quote-character (^XQ) command as follows:


     ^XQ-Tab           Inserts a hard tab

If you prefer using hard tabs exclusively instead of the
software-driven spaces, you can give the tab command a numeric argument
of zero, in which case, SAIL will use hard tabs.  This may be given
from the keyboard (Esc-0 Tab) or as a line in your SAIL.SET file as
follows.


     0 tab




HELP

     Help screens contain information such as editing or key sequences
needed to issue commands.  You may ask for help at any time while
editing.  Just press F1.  (If you cannot access the help screen by
pressing F1, read the section entitled "EXECUTION ENVIRONMENT" in
Chapter 2 and install SAIL properly.)

     The information presented in the help screens are valid for the
default SAIL key assignments.  If you change the key assignments,
remember that the help screens will not apply to the new key
assignments.

     Once you call the Help screen you will be presented with a menu of
9 selections.  Each number corresponds to a specific topic.  Enter a
number from 1 to 9 for help on the appropriate topic.

     For example, if you want help on the subject "Cursor Keys and
Editing", enter the numeral 1.  When you enter the numeral 1, SAIL
displays the help information for that topic.




                                                                    7-27
SAIL EDITING ENVIRONMENT




More Flag

     When the help for a topic is longer than one screen, a "More" flag
will appear at the bottom right corner.  The More flag means that there
is more information on the next screen.



Next Screen

     When the More flag is displayed, enter the PgDn key to view the
next screen.



Previous Screen

     At any level other than the top level menu, pressing the PgUp key
displays the previous screen.



Top Menu

     At any level other than the top level menu, pressing the Home key
takes you to the top level menu.



Exiting help

     At any level, pressing the End key exits help and returns you to
editing.



Help on single keys

     For help on a single key, use the test-key command.  When the
test-key (Esc-?) command is entered, SAIL waits for the next command to
be entered, and responds on the message line with a short description
of the command entered.








7-28
                                                      EDITING FACILITIES




Help on the command line

     Help is also available the SAIL command line at the DOS level.
Use the /HELP option.  The /HELP option is described in the section
entitled "COMMAND LINE HELP" in Chapter 3.













































                                                                    7-29







CHAPTER 8  ADVANCED TOPICS



COMMAND ASSIGNMENTS

     Not counting self-insert, over 100 commands are built into SAIL.

     When a key sequence is entered, it is passed to SAIL's command
interpreter, which interprets the commands and executes them.  Every
time a key is hit, the command interpreter looks up that key sequence
in its key/command translation table, and upon a match, it invokes the
corresponding command.  This happens very quickly.

     Commands may also be entered by their mnemonic names instead of
key sequences.  When a mnemonic name is entered, the command
interpreter searches for that command name in its name/command
translation table, and invokes the corresponding command.

     It may be useful to visualize the command interpreter as in the
following diagram.


     1. Key sequences
        from operator
            |                   Memory
            v
     -----------------     -----------------     -----------------
     |  SAIL Command | --> |     Text      | --> |     Text      |
     |  Interpreter  |     |    Buffer     |     |    Window     |
     -----------------     -----------------     =================
            ^              -----------------     |     Text      |
            |              |     Text      | --> |    Window     |
     2. Mnemonic names     |    Buffer     |     -----------------
        from a buffer     -----------------       Display Screen
        (BREEZE macro              .
         language)                 .
                           -----------------
                           |     Text      |
                           |    Buffer     |
                           -----------------


            SAIL's command interpreter interprets the commands.






                                                                     8-1
SAIL EDITING ENVIRONMENT




     As shown in the diagram, there are two ways to send commands to
the command interpreter:  (1) enter keystrokes, and (2) pass the
mnemonic names of commands.



Key sequences

     In case 1 above, key sequences are sent to the command
interpreter, which deciphers non-printing characters such as Alt-S,
Escape-J, etc., to be commands corresponding to save to a file and to
justify.

     As a matter of fact, in SAIL, all the printing characters -- such
as the letters from A to Z and the numbers from 0 to 9 -- are
considered as causing "self-insert" commands, commands to insert the
corresponding letter into the buffer.

     Key combinations for editing commands can be entered by shifting
down the Control or Alt keys, or with the ^X and Esc prefix commands.

     When either prefix command is entered, SAIL waits for another key
(or key sequence), and interprets the overall key sequence to execute
the command.  Many of the predefined commands are assigned in this
manner.  After experience with SAIL you will probably want to optimize
the key assignments for your own editing style.

     SAIL keeps its key sequences and the commands they correspond to
in its key assignment table, and allows you to rewrite the key
assignment table.  This table is a large list of the key sequences and
the commands that correspond to them.  Entries in this table can be
changed, and when this is done, the keyboard configuration can be
rearranged so that different keys will evoke the commands.

     In order to reassign keys, we must first also discuss mnemonic
names and talk about the BREEZE macro programming language.



Mnemonic names

     SAIL provides a second way to pass commands to the command
interpreter.  This forms the basis for its macro programming language,
BREEZE.  In case 2 above, when mnemonic names are passed to the command
interpreter, the command interpreter recognizes the mnemonic names such
as save_file and justify, to be commands to save to a file and to




8-2
                                                         ADVANCED TOPICS




justify.

     This is possible because in addition to the key assignment table
discussed above, SAIL has a name assignment table.  This table is a
large list of the mnemonic names and the commands that correspond to
them.

     These mnemonic names can be passed as a single command, a command
line, and as macro files and buffers.

     The following section will show you how you can pass mnemonic
names of commands to the command interpreter, and how you can store
lists of commands in files or buffers for later execution.



MACRO FILES AND BUFFERS

     Command files and command buffers are special types of files and
buffers containing the mnemonic names of commands to be sent to SAIL's
command processor.  Mnemonic names are tabulated in the Appendices.

     One example of a command file is the SAIL.SET file, which is
executed whenever SAIL is called from DOS.  Prewritten command
sequences can be called during an editing session, simplifying the
execution of commands entered repeatedly.

     Commands can be combined in any manner and is only limited by your
imagination.  For example, you can use the command files and buffers to
reassign the keys needed to evoke commands.  Since they are stored,
once written, you can read a specific file in order to set the new key
assignments.

     In general, macros work identically as files or buffers, except
that when SAIL is given a macro file to execute, it reads the file into
a buffer first.



Writing Command Files/Buffers

     Command files and command buffers are text files.  The command
line has the following formal syntax:


     [[-]<argument>] <command-name>[ {[[<number>]...] | [["<string>"]...]}]




                                                                     8-3
SAIL EDITING ENVIRONMENT




                               OR

     ; Comments ignored by the command interpreter.

where:


     [-]             An optional negative sign for the integer.
     <argument>      An optional integer numeric argument.
     <command_name>  The mnemonic name of the SAIL command.
     <number>        The command's numeric parameter(s).
     <string>        The command's string parameter(s).


     Lines with a semicolon (;) in column one are taken to be comments,
and are simply ignored by the command processor.

     Only one command is allowed per line.  If an <argument> is given,
a space must separate the <argument> and <command_name>.  In addition,
if the <number> or <string> parameters are given, a space must separate
them from the <command_name>.

     In general, command buffers are best written in interactive mode
as an iterative process.  Use SAIL to write a list of commands, then
save the buffer to a file.  When you are ready, execute the buffer
(Alt-B).



Sample macros

     The following macro sets EXACT and WRAP modes globally, and sets
the margin to 72 and tabstops to 3 spaces.  These are typical commands
found in the SAIL.SET file.


     ; SAIL.SET
     ;
     ; Set EXACT and WRAP modes for all files.
     set_global_mode EXACT
     set_global_mode WRAP
     ;
     ; Set the right margin to column 72.
     72 set_margin
     ;
     ; Set tab stops at every three columns.




8-4
                                                         ADVANCED TOPICS




     3 tab


     The following macro reassigns function keys F1 to F5.


     ; FUNCTION KEY REASSIGNMENT
     ;
     ; This macro file reassigns function keys F1 to F5.
     ;
     assign_key search_forward Alt-;
     assign_key search_back    Alt-<
     assign_key save_file      Alt-=
     assign_key write_file     Alt->
     assign_key write_quit     Alt-?




Executing command files

     The execute_file (Esc-F) and execute_buffer (Esc-B) commands are
used to execute commands from files or buffers.  In response to the
entry of one of the above two commands, SAIL prompts you for the name
of a file or buffer.

     When a name is provided, the SAIL command interpreter then
interprets the command lines, and executes them as if they had been
entered from the keyboard.



MACRO DEBUGGING FACILITIES

     While this manual gives instructions on macro programming, there
are limited facilities to assist you in debugging.  This version of the
BREEZE macro language is experimental and is subject to change.
Software Creations is putting development effort in improving the macro
language.  As we anticipate a lot of interest in this area, however, we
are providing the following description despite its limitations.

     Presently, if you want to develop macros, we advise that you start
by assigning the execute_line command as follows:


     assign_key execute_line <key sequence>




                                                                     8-5
SAIL EDITING ENVIRONMENT




     Using the execute_line command, you can test the syntax of single
lines that you plan to include in your completed macro.

     After you have created your macro buffer, be sure to save all your
buffers before executing the macro.  Double check your commands,
especially the command name field, because a macro file containing an
undefined command name can cause the current version of the macro
language to produce unpredictable results, and even go into an endless
loop.  But with careful cross checking, and lots of patience, it is
possible to create some very useful macros.  The macro examples above
were developed in this manner.

     If you come up with good macros that you would like to share, by
all means forward it to us and we'll include the good ones with the
next version.  There are probably lots of people looking for the same
solutions.



CUSTOMIZATION

     Once you master SAIL you will want to customize it for your
editing style.  The SAIL.SET file, because it is always read from disk
before starting the editor, provides you with a way to set parameters
for editing that you want to have set every time you begin an editing
session.



DOS INTERFACE

     The system commands are intended for advanced users, and allow you
to run a single DOS command or to escape to DOS by running a second
copy of the command interpreter.

     For example, you may want directory information from the disk.
Instead of having to save your file before quitting SAIL, then running
the DOS DIR command, then reloading SAIL and your file, you can give
commands directly to DOS.



RUNNING A DOS COMMAND

     To issue a single DOS command, enter the dos_command (Alt-C)
command, followed by the DOS command.  Thus, to take the directory of




8-6
                                                         ADVANCED TOPICS




the current drive, you would enter "Alt-C dir" to get the directory.
This is a simplified diagram of what happens.


                                       Alt-C + DOS
                                         command -------------------
               Start SAIL                   ---->| DOS Interpreter |
                from DOS -------------------     -------------------
                   ----->|      SAIL       |     |      SAIL       |
-------------------      -------------------     -------------------
| DOS Interpreter |      | DOS Interpreter |     | DOS Interpreter |
-------------------      -------------------     -------------------
                  <-----                   <-----
               Quit editor             End of command


                    Executing a single DOS command.



DOS AS A CHILD PROCESS

     If the task you wish to do requires several commands, you can also
call DOS by running a second copy of the command interpreter
(COMMAND.COM) by entering the dos_shell (Alt-O) command.  The second
command interpreter then interprets your DOS commands.  The following
is a simplified diagram of what happens:


                                       Alt-O + DOS
                                        commands -------------------
               Start SAIL                   ---->| DOS Interpreter |
                from DOS -------------------     -------------------
                   ----->|      SAIL       |     |      SAIL       |
-------------------      -------------------     -------------------
| DOS Interpreter |      | DOS Interpreter |     | DOS Interpreter |
-------------------      -------------------     -------------------
                  <-----                   <-----
               Quit editor              EXIT command


                  Suspending SAIL to do DOS commands.








                                                                     8-7
SAIL EDITING ENVIRONMENT




     Note that when SAIL executes the above two commands, it runs a
second copy of the DOS command interpreter, but still occupies memory
in the system;  and thus the performance of memory-intensive
applications (such as compilers or spreadsheet programs) may be
reduced.

     The SAIL DOS commands were intended to support editing.  With
imaginative use (along with lots of memory) it is possible to use them
to create your own integrated programming environment.



DESKTOP PUBLISHING

     SAIL allows an easy way to apply your present equipment for new
applications such as Desktop Publishing.  Since SAIL produces pure text
files (ASCII text files), it can be used with existing equipment for
text entry as a step to Desktop Publishing.

     The next diagram shows an example of how SAIL could be used in an
office to prepare material for a periodical or a small publication, or
even a computer manual.  This manual itself was written exclusively
with SAIL.



























8-8
                                                         ADVANCED TOPICS




     --------------          --------------
     |            |          |            |
     |    SAIL    |          |    SAIL    |     Preparation
     |            |          |            |     of documents,
     --------------          --------------     editing,
      /          \            /          \      finalization
      ------------            ------------
                                                    |
      1. Networked or standalone computers      ASCII text
                                                  files
                                                    |
       ----------              ----------           v
       |        |              |        |       Page layout
       |        |              |        |       and font
       |--------|              |--------|       selection
       |     ---|              |     ---|
       ----------              ----------           |
                                               Printer data
              2. Bit-mapped computers               |
                                                    v

              =====================
              ---------------------
              |                   |            Camera-ready
              |                   | /             copy
       ----   |                   |/
           ---|                   |
              =====================

           3. Laser printing technology


     Note that we are not suggesting that the quality of output from
current laser printing technology is equal to the work of professional
typesetters.



SOFTWARE DEVELOPMENT

     SAIL can also be easily integrated into software development.
Since SAIL produces plain (ASCII) text files, its use can cut the
production costs of the preparation of source files for compilers.

     This is especially true in the advanced stages of large projects,
where the management of multiple files and buffers become an issue as




                                                                     8-9
SAIL EDITING ENVIRONMENT




entire sections of code need to be moved accurately between and
coordinated between numerous modules.  Compared to WordStar and vi, the
two most common editors in the sub-mainframe programming environment,
SAIL is the editor of choice because it can transfer modules easily.



     --------------          --------------
     |            |          |            |
     |    SAIL    |          |    SAIL    |     Programming
     |            |          |            |     team preparing
     --------------          --------------     modules
      /          \            /          \
      ------------            ------------
                                                     |
          Networked or standalone computers          |
                                                     v
                 --------------
                 |            |          Module integration
                 |    SAIL    |          with cut and put,
                 |            |          module comparison
                 --------------          and correction using
                  /          \           multiple buffers/windows
                  ------------


     Even programmers working alone can use SAIL to increase
productivity by taking advantage of source code libraries.



                                       Existing source code

                                               |
                                               v
               --------------
               |            |          Integration of source
               |    SAIL    |          code using copy and
               |            |          put, modification
               --------------          with multiple buffers
                /          \
                ------------                  |
                                              v

                                       New applications





8-10
                                                         ADVANCED TOPICS




A traditional test of an editor's effectiveness is whether it can be
used to develop itself.  SAIL was used exclusively in preparing text
files for the compiler and macroassembler the latter stages of its own
development, and is being used exclusively for programming all its
updates.













































                                                                    8-11


                                                       COMMAND REFERENCE







CHAPTER 9  COMMAND REFERENCE

     This chapter contains a reference guide for SAIL and its BREEZE
macro programming language.  If you are new to SAIL, we recommend that
you read Chapters 1 to 8 to familiarize yourself with editing with SAIL
and learn how to use macros.  As you gain experience with SAIL, you
will probably want to learn the editing commands in greater detail, and
may even want to program using the macro programming language.  Use the
information in this chapter to assist you in getting more from your
editor.

     The following is an alphabetical list of SAIL commands, their key
assignments, and a short description of their function.  Each entry
also has a note on whether the command can take numeric arguments.
Most entries also have a cross-reference listing to refer you to other
related SAIL commands.  Block related commands that clear out the
notepad are also indicated.



COMMAND DESCRIPTION FORMAT

mnemonic-name keystroke (Name)

     General command description, and examples of when it is
     appropriate to use the command.

     Notepad, if any.

     (Numeric arguments).

     See also:  names of related commands.
















                                                                     9-1
SAIL EDITING ENVIRONMENT




abort ^C

     The abort command interrupts the command being executed.  It
     is used to cancel commands that require additional
     information.

     (Ignores numeric arguments).




assign-key  Esc-K                                                  (Key)

     The assign-key command assigns a command to a designated key
     sequence.

     For example, you may have trouble remembering that SAIL uses
     ^S for its search-forward command.  Thus you want to change
     the key assignment for search-forward from ^S to Alt-F1.  Add
     the following line to the SAIL.SET file so that you can use
     Alt-F1.

          assign-key search-forward Alt-;

     After you execute the buffer or file containing the above two
     commands, instead of pressing ^S for search, use Alt-F1.

          SAIL adds the key assignment to the end of its key
          assignment table.  Therefore, the key sequence you
          assign cannot be assigned to another command,
          because that command will be called instead.

     For details on how to change key assignments, read the related
     sections in Chapters 7 and 8.

     (Ignores numeric arguments).

     See also:  free-key.













9-2
                                                       COMMAND REFERENCE




begin-macro  Esc-(                            (Left parentheses = start)

     The begin-macro command instructs SAIL to record keystrokes
     until the end-macro command is entered.  The keystrokes thus
     recorded in the key macro can be played back with the
     execute-macro command.  This is useful when it is necessary
     to enter the same text or commands repeatedly.

          Note that SAIL reserves enough memory for 500
          keystrokes (6 full lines) in its macro memory.  For
          editing longer tasks, we suggest that you use the
          block commands.

     During the definition of a key macro, if the abort command (^C) is
     entered, the key macro definition is forcibly terminated.

     (Ignores numeric arguments).

     See also:  end-macro, execute-macro.




bol  ^Up

     The bol command moves the cursor to the beginning of the
     current line.  This command is ignored if the cursor is
     already at the beginning of a line.

     (Ignores numeric arguments).

     See also:  eol.



















                                                                     9-3
SAIL EDITING ENVIRONMENT




bop  Home

     The bop command moves the cursor to the first letter of the
     paragraph containing the cursor.  If the cursor is already at
     the first letter of a paragraph, this command moves the
     cursor to the beginning of the previous paragraph.

          If the cursor is at the first paragraph of the
          buffer, and the first two letters of the buffer are
          visible, this command will move the cursor to the
          second letter of the buffer.

     (Uses numeric arguments).

     See also:  eop.




bottom  ^End

     The bottom command moves the cursor to the location after the
     last character at the end of the buffer.

          Note that the last character in the buffer may be
          an invisible letter, such as a space or a tab.

     (Ignores numeric arguments).

     See also:  top.





















9-4
                                                       COMMAND REFERENCE




capitalize-word  ^XI                                      (Initial caps)

     The capitalize-word command capitalizes the first letter of
     the word that follows the cursor, provided that the cursor is
     at first letter of the word or the space between words.  If
     the cursor is in the middle of a word, this command
     capitalizes the letter at the cursor.  After capitalization,
     the cursor is moved to the first space following the
     capitalized word.

     (Uses numeric arguments).

     See also:  caps-word, lower-word.




caps-block  Esc-U                                            (Uppercase)

     The caps-block command capitalizes all letters between the
     cursor and the begin-block mark.

     (Ignores numeric arguments).

     See also:  lower-block.




caps-word  ^XU                                               (Uppercase)

     The caps-word command capitalizes the word that follows the
     cursor, provided that the cursor is at the first letter of a
     word or at the space between words.  If the cursor is in the
     middle of a word, this command capitalizes the rest of the
     word.  After capitalization, the cursor is moved to the first
     space following the capitalized word.

     (Uses numeric arguments).

     See also:  capitalize-word, lower-word.










                                                                     9-5
SAIL EDITING ENVIRONMENT




center-cursor  ^P                                           (Put cursor)

     The center-cursor command causes the text, along with the
     cursor, to shift (up or down) so as to place the cursor at
     the center of the current window.  This command is ignored at
     first half-window of a buffer.

     (Ignores numeric arguments).

     See also:  redraw.




close-other-windows  Esc-1                                  (One window)

     The close-other-windows command closes all other windows on
     the screen to make the current window the only window on the
     screen.  This command is ignored if there is only one window
     on the screen.

     (Ignores numeric arguments).

     See also:  split.




copy-block  Esc-C                                                 (Copy)

     The copy-block command copies the text betweeen the cursor
     and the begin-block mark to the notepad.  This is one way to
     move text around in the buffer.

          Note that the begin-block mark must have been set,
          using the set-mark command, before this command may
          be carried out.

     Clears notepad.

     (Ignores numeric arguments).

     See also:  delete-block, put.








9-6
                                                       COMMAND REFERENCE




delete-blank-lines  ^XD                                         (Delete)

     The delete-blank-lines command deletes all blank lines above
     and below the cursor, closing up the empty space between two
     paragraphs.  This command works as long as the cursor is on
     one of the blank lines between two paragraphs.  The blank
     lines may not contain spaces or tabs.  The command does
     nothing if the cursor is not at a blank line.

     (Ignores numeric arguments).




delete-block  Esc-Y                                               (Yank)

     The delete-block command deletes the text between the cursor
     and the begin-block mark, and places a copy of the deleted
     text in the notepad.  This is one way to move text around in
     the buffer.

          Note that the begin-block mark must have been set,
          using the set-mark command, before this command may
          be carried out.

     Clears notepad.

     (Ignores numeric arguments).

     See also:  copy-block, put.





















                                                                     9-7
SAIL EDITING ENVIRONMENT




delete-buffer  Alt-K                                              (Kill)

     The delete-buffer command prompts for the name of the buffer
     to delete.  Upon entering the name of the buffer and pressing
     Return, all text in that editing buffer is deleted.  If the
     buffer had been changed, you are asked to confirm your
     intention to discard the buffer.

          Note that once a buffer is deleted, its text cannot
          be recovered.

     The delete-buffer command only works on non-displayed buffers;  an
     error results if an attempt is made to delete an onscreen buffer.

     (Ignores numeric arguments).




delete-left  Backspace

     The delete-left command deletes the character preceding the
     cursor, moving the rest of the line, if present, one column
     to the left.  If this command is given at the beginning of a
     line, the carriage return separating the two lines is
     deleted, causing the current line to join the previous line.

     (Uses numeric arguments).

     See also:  delete-right.





















9-8
                                                       COMMAND REFERENCE




delete-paragraph  ^Y                                              (Yank)

     The delete-paragraph command deletes the paragraph containing
     the cursor, or, if the cursor is not within a paragraph, the
     paragraph following the cursor, and moves the text that
     follows the deleted paragraph up to close up the space.  If
     the cursor is at the end of the buffer, the last paragraph in
     the buffer is deleted.

     Clears notepad.

     (Uses numeric arguments).




delete-right  Delete

     The delete-right command deletes the character after the
     cursor, moving the rest of the line, if present, one column
     to the left.  The position of the cursor is unaffected.  If
     this command is given at the end of a line, the carriage
     return separating the two lines is deleted, causing the next
     line to join the current line.

     (Uses numeric arguments).

     See also:  delete-left.




delete-to-eol  ^XY                                                (Yank)

     The delete-to-eol command deletes all text between the cursor
     and the end of the line.  If this command is given at the end
     of a line, the carriage return separating the two lines is
     deleted, causing the next line to join the current line.

     Clears notepad.

     (Uses numeric arguments).









                                                                     9-9
SAIL EDITING ENVIRONMENT




delete-word-left  ^Backspace

     The delete-word-left command deletes the word preceding the
     cursor, unless the cursor is in the middle of a word, when it
     deletes to the beginning of the word.  The deleted word is
     added to the text in the notepad, and the cursor moves to the
     space that preceded the deleted word.

     Clears notepad.

     (Uses numeric arguments).

     See also:  delete-word-right.




delete-word-right  ^Delete

     The delete-word-right command deletes the entire word
     following the cursor, unless the cursor is in the middle of a
     word, when it deletes to the end of the word.  The deleted
     word is added to the text already in the notepad.

     Clears notepad.

     (Uses numeric arguments).

     See also:  delete-word-left.




dos-command  Alt-C                                             (Command)

     The dos-command command prompts for, then executes, a DOS
     command line.  When the prompt appears, enter the DOS command
     line.  For example, to take the directory of the current disk
     drive, enter DIR and press Return.

          Note that there must be sufficient memory for
          execution of this command;  if not, SAIL will
          return a message.

     In general, this command may be used with any DOS command line;
     however, several factors, namely, the size of the buffers
     currently being edited, the free RAM size, and the space required
     for DOS environment variables, may prevent very large programs
     from working properly.  For details on DOS commands, refer to your
     DOS User's Manual or the documentation for your application.

9-10
                                                       COMMAND REFERENCE




     (Ignores numeric arguments).

     See also:  dos-shell.




dos-shell  Alt-O                                      (Operating System)

     The dos-shell command allows you to temporarily leave SAIL to
     use DOS commands.

     In response to this command, SAIL outputs a message as
     follows.

          Enter the EXIT command when done with DOS

     At this point, you can enter DOS command lines, such as the DIR
     command to to take the directory of the current disk drive, etc.
     When you want to return to SAIL, enter the following DOS command:

          EXIT

     Upon reentry into SAIL, the current buffer will be redisplayed,
     and you can continue editing.

     If there is insufficient space for the execution of external
     commands, SAIL will return a message, and this command does
     nothing.  In general, the same size restrictions that apply to the
     dos-command command above apply to the dos-shell command.  For
     details on DOS commands, refer to your DOS User's Manual.

     (Ignores numeric arguments).

     See also:  dos-command.
















                                                                    9-11
SAIL EDITING ENVIRONMENT




down  Down

     The down command moves the cursor to the next line;
     maintaining the cursor's column position, or seeking the
     rightmost column closest to the current column.

     (Uses numeric arguments).

     See also:  up.




edit-buffer  Alt-U                                                 (Use)

     The edit-buffer command prompts for the name of a buffer to
     edit.  If the name given is the name of an existing buffer,
     that buffer is selected;  otherwise, SAIL creates a new
     (empty) buffer, and selects that buffer.

     (Ignores numeric arguments).

     See also:  next-buffer.




edit-file  Alt-E                                                  (Edit)

     The edit-file command prompts for the name of a file to
     edit.  If the name given is the name of an existing buffer,
     that buffer is selected;  otherwise, SAIL creates a new
     buffer, reads the disk file's contents, if present, into the
     buffer, then selects that buffer.

     If the file name (taken from the path name given) is already
     being used by another buffer, SAIL prompts for a new name for
     the buffer.

     (Ignores numeric arguments).

     See also:  view-file.









9-12
                                                       COMMAND REFERENCE




end-macro  Esc-)                               (Right parentheses = end)

     The end-macro command instructs SAIL to stop memorizing
     keystrokes begun with the begin-macro command.  The
     keystrokes thus saved in the key macro can be executed with
     the execute-macro command.  This is useful when it is
     necessary to enter the same commands repeatedly.

     (Ignores numeric arguments).

     See also:  begin-macro, execute-macro.




enlarge  ^U                                                         (Up)

     The enlarge command enlarges the height of the current window
     by one line, while decreasing the adjacent window by one
     line.  This command is valid only when there is more than one
     window on the screen.  In addition, there must be space
     remaining in the adjacent window to shrink (the adjacent
     window must be larger than one line).

     (Uses numeric arguments).

     See also:  shrink.




eol  ^Down

     The eol command moves the cursor to the end of the current
     line.  This command is ignored if the cursor is already at
     the end of the line.

     (Ignores numeric arguments).

     See also:  bol.











                                                                    9-13
SAIL EDITING ENVIRONMENT




eop  End

     The eop command moves the cursor to the end of the paragraph
     containing the cursor.

          Note that since the paragraph may be followed by
          spaces, the cursor may appear to move to an
          invisible character.

     (Uses numeric arguments).

     See also:  bop.




exchange  ^XE                                                 (Exchange)

     The exchange command interchanges the two characters before
     and at the cursor.  This command does nothing if the cursor
     is at the first character of a line.

     (Ignores numeric arguments).




execute-buffer  Esc-B                                           (Buffer)

     The execute-buffer command prompts you for the name of the
     buffer containing instructions written in the BREEZE macro
     language, and executes the commands in that buffer.

     (Uses numeric arguments).

     See also:  execute-file.















9-14
                                                       COMMAND REFERENCE




execute-file  Esc-F                                               (File)

     The execute-file command prompts you for the name of a file
     containing instructions written in the BREEZE macro language,
     and executes the commands in that file.

     (Uses numeric arguments).

     See also:  execute-buffer.




execute-macro  Esc-E                                           (Execute)

     The execute-macro command instructs SAIL to play back the
     keystrokes recorded in the key macro at the current cursor
     position, as if the keystrokes were typed on the keyboard.

     The execute-macro command is useful when it is necessary to
     enter the same commands repeatedly.

          Note that in order for a key macro to be executed,
          a key macro must have first been defined, using the
          begin-macro and end-macro commands.

          Since the execute-macro command itself can take
          numeric arguments, this command can be used to
          repeat commands that cannot normally take numeric
          arguments.  Simply embed the command that must be
          repeated in the key macro definition.

     (Uses numeric arguments).

     See also:  begin-macro, end-macro.
















                                                                    9-15
SAIL EDITING ENVIRONMENT




free-key  ^XK                                                      (Key)

     The free-key command resets the assignment for a given key
     sequence.  After this command is given, the key no longer
     KILROY

     (Ignores numeric arguments).

     See also:  assign-key.




goto  ^G                                                          (Goto)

     The goto command moves the cursor to the nth line of the
     buffer.  The n is the numeric argument that precedes the
     command (entered by Esc followed by a number;  or ^V).  If no
     numeric argument had been provided, this command moves the
     cursor to the first line of the buffer.

     (Uses numeric arguments).




help  F1

     The help command displays the help screens.  When the help
     command is given, a menu is output, and SAIL waits for you to
     enter a number from 1 to 9, depending on the topic that you
     wish to read about.  For example, if you wish to read about
     "Search and Replace", enter the number 5.

     When a number is selected, the help screen corresponding to
     the topic is displayed.  If there are more screens on that
     topic, a "More" flag will appear at the bottom right of the
     screen, in which case, you can view the additional
     information by pressing the PgDn key.

     From any point in the help screen heirarchy, you may go back
     to the top menu by entering Home.  In addition, at the
     sub-screens, you may go up to the next level by pressing
     PgUp.

     To exit help, press the End key.

     If you enter help and the help screens do not appear, read
     the section entitled "EXECUTION ENVIRONMENT" in Chapter 2.


9-16
                                                       COMMAND REFERENCE




     (Ignores numeric arguments).

     See also:  test-key.




justify  Esc-J                                                 (Justify)

     The justify command justifies the paragraph containing the
     cursor.  The length of each line in the paragraph is
     determined by the right margin.  (Paragraphs are considered
     to be the text between two subsequent newlines).  After
     justification, the cursor is moved to the position following
     the paragraph.  If the paragraph goes beyond the bottom of
     the current window, the window is scrolled up, placing the
     cursor in the center of the window.

     (Ignores numeric arguments).

     See also:  set-margin.




left  Left

     The left command moves the cursor one character to the left
     in the buffer.  If the cursor is at the beginning of the
     line, it is moved to the end of the previous line.

     (Uses numeric arguments).

     See also:  right.

















                                                                    9-17
SAIL EDITING ENVIRONMENT




list-buffers  Alt-D                                          (Directory)

     The list-buffers command displays the directory of all
     buffers currently being processed by SAIL.

     (Ignores numeric arguments).




lower-block  Esc-L                                           (Lowercase)

     The lower-block command converts all letters between the
     cursor and the begin-block mark to lower case.

     (Ignores numeric arguments).

     See also:  caps-block.




lower-word  ^XL                                              (Lowercase)

     The lower-word command converts the word that follows the
     cursor to lower case, provided that the cursor is at the
     first letter of a word or at the space between two words.  If
     the cursor is in the middle of a word, this command converts
     the rest of the word to lower case.  After conversion, the
     cursor is moved to the first space following the processed
     word.

     (Uses numeric arguments).

     See also:  caps-word, capitalize-word.
















9-18
                                                       COMMAND REFERENCE




merge-file  Alt-M                                                (Merge)

     The merge-file command prompts for the name of a file to
     merge.  If the file exists and can be read, its contents are
     inserted into the current buffer at the line preceding the
     cursor, and the cursor is moved to the position following the
     merged file;  otherwise, an error is reported and no change
     is made.

     (Ignores numeric arguments).

     See also:  read-file.




mode  F10

     The mode command displays the mode screen so that the edit
     modes for the current buffer can be changed.

     In the scope field, one of the two marks will be highlighted,
     indicating the scope of the change:  current buffer or global
     buffers.  The PgUp/PgDn keys allow switching between scopes.

     In the Off/On field, one of the 10 modes will be highlighted,
     indicating the mode affected.  The Up and Down arrows move
     the highlight.  Once the mode is selected, pressing the Right
     cursor key turns a mode on, and pressing the Left cursor key
     turns a mode off.

     The End key returns to editing.

     (Ignores numeric arguments).

     See also:  set-global-mode, set-mode, reset-global-mode,
                reset-mode.














                                                                    9-19
SAIL EDITING ENVIRONMENT




newline  Return

     The newline command inserts a carriage return into the
     current line at the cursor, and moves the cursor to the
     beginning of the newly created line.

     (Uses numeric arguments).

     See also:  newline-indent, open-line.




newline-indent  ^J

     The newline-indent command, in addition to performing the
     same function as the newline command, indents, by inserting
     spaces, to copy the indentation from the previous line.

     (Uses numeric arguments).

     See also:  newline, open-line.




next-buffer  Alt-N                                                (Next)

     The next-buffer command switches editing to the next buffer
     (in the buffer directory) when editing multiple buffers.  If
     there is no other buffer to be edited, this command moves the
     cursor to the center of the screen.

     (Uses numeric arguments).

     See also:  edit-buffer.















9-20
                                                       COMMAND REFERENCE




open-line  ^N                                                  (Newline)

     The open-line command places a carriage return in the file,
     leaving the cursor position unchanged.

     (Uses numeric arguments).

     See also:  newline, newline-indent.




page-down  PgDn

     The page-down command displays the next page of text (down in
     the file) by moving all text in the window up such that the
     bottom line of the window is moved to the top of the window.
     The cursor is moved to the beginning of the line at the top
     of the window.

     (Uses numeric arguments).

     See also:  page-up.




page-down-next  ^Z

     The page-down-next command does a page-down command on the
     next (down on the screen) window.  An error is returned if
     there is only one window on the screen.

     (Uses numeric arguments).

     See also:  page-up-next.















                                                                    9-21
SAIL EDITING ENVIRONMENT




page-up  PgUp

     The page-up command displays the previous page of text (up in
     the file) by moving all text in the window down such that the
     top line of the window is moved to the bottom of the window.
     The cursor is moved to the beginning of the line at the top
     of the window.

     (Uses numeric arguments).

     See also:  page-down.




page-up-next  ^W

     The page-up-next command does a page-up command on the next
     (down on the screen) window.  An error is returned if there
     is only one window on the screen.

     (Uses numeric arguments).

     See also:  page-down-next.




put  Esc-P                                                         (Put)

     The put command inserts, at the cursor, all text in the
     notepad.  The cursor moves to the end of the inserted block.

     (Uses numeric arguments).

     See also:  copy-block, delete-block.















9-22
                                                       COMMAND REFERENCE




query-replace  Esc-Q                                             (Query)

     The query-replace command prompts for two strings:  a search
     string and a replacement string.  After entering the strings,
     SAIL steps through the file, stopping whenever the search
     string is found.  You must then enter one of the following
     letters:  Y, N, ^C, G, S, H.
          Y  Replace one      N  Skip one        ^C  Cancel command
          G  Replace rest     S  Exit to start    H  List these options

     (Ignores numeric arguments).

     See also:  replace.




quit  Alt-Q                                                       (Quit)

     The quit command exits SAIL and goes back to the operating
     system (DOS).

     Upon execution of the quit command, SAIL checks if there are
     any buffers which had been changed but not saved.  If there
     are no unsaved changes, SAIL exits without further
     questions.  If there are unsaved changes, SAIL asks for
     confirmation with the following question:

          Abandon unsaved change(s) (y/n)?

     At this point, if you enter Y, meaning yes, SAIL abandons all
     changes, and exits to DOS, discarding all edits on all buffers
     since the last save-file, write-file, or zap command.

     If you enter N, meaning no, SAIL ignores the command, and you are
     placed back in your buffer as if the quit command had not been
     issued.

     (Ignores numeric arguments).

     See also:  save-file, write-file, zap.










                                                                    9-23
SAIL EDITING ENVIRONMENT




quote-character  ^XQ                                             (Quote)

     The quote-character command takes the next character as a
     literal character for insertion.  This command is used to
     quote special characters (such as ^Z) for insertion into the
     buffer which normally would be interpreted as commands.

     (Uses numeric arguments).




re-search-back  ^B                                            (Backward)

     The re-search-back command searches the buffer backward for
     the string used in the previous search or replace command.
     This command does nothing if there was no previous search or
     replace command in the current editing session.

     (Uses numeric arguments).

     See also:  re-search-forward.




re-search-forward  ^F                                          (Forward)

     The re-search-forward command searches the buffer forward for
     the string used in the previous search or replace command.
     This command does nothing if there was no previous search or
     replace command in the current editing session.

     (Uses numeric arguments).

     See also:  re-search-back.















9-24
                                                       COMMAND REFERENCE




read-file  Alt-R                                                  (Read)

     The read-file command prompts for the name of a file to read
     into (and replace the text in) the current buffer.

     If the current buffer had been changed, SAIL asks you to
     confirm the intention to discard the changes, because the
     read-file command will erase them.

     At that point, if you answer N, for no, editing proceeds as
     if the command had not been called.

     If you confirm with Y, meaning yes, the disk file is read,
     overwriting the contents of the current buffer, and the
     cursor is moved to the first position of the buffer.  If the
     disk file did not exist, or was empty, the current buffer is
     simply cleared.

     After reading the file, the name assigned to the file is
     updated.  The read-file command provides an easy way to
     discard changes to the current buffer and start editing the
     file all over without having to exit SAIL.

     (Ignores numeric arguments).

     See also:  merge-file, view-file.




redraw  ^L                                               (^L = Formfeed)

     The redraw command redraws the screen.  This is sometimes
     necessary if you search for a very long string and the status
     line disappears, or if a SAIL command, or the output from
     another program executed from a DOS command, causes spurious
     characters to appear on the screen.

     (Ignores numeric arguments).

     See also:  center-cursor.










                                                                    9-25
SAIL EDITING ENVIRONMENT




rename-buffer  Alt-B                                            (Buffer)

     The rename-buffer command prompts for a new name for the
     current buffer.  After a name for the buffer is entered, the
     name provided becomes the new name for the buffer, and this
     is reflected on the status line and in the buffer directory.

     If no name is provided, this command is ignored.

     (Ignores numeric arguments).

     See also:  rename-file.




rename-file  Alt-F                                                (File)

     The rename-file command prompts for, and changes, the file
     name assigned to the current buffer.  When a name is
     provided, it is reflected on the status line and in the
     buffer directory.

     If no name is provided, the file name is cleared.

     (Ignores numeric arguments).

     See also:  rename-buffer.




repeat  ^V

     The repeat command multiples the numeric argument by four.
     When entered before another command, the repeat command
     causes the command to be repeated 4 times.  If the repeat
     command is entered twice, the numeric argument becomes 16.
     For example, to move the cursor 16 columns to the right,
     enter ^V^VRight.

          Depending on the command that follows it, large
          arguments (>= 1000) may take some time to
          complete.

     (Ignores numeric arguments).





9-26
                                                       COMMAND REFERENCE




replace  Esc-R                                                 (Replace)

     The replace command is the same as query-replace, except that
     the replace is done without pausing for confirmation.

     (Ignores numeric arguments).

     See also:  query-replace.




report-character  ^X=

     The report-character command displays the decimal,
     hexadecimal, and octal codes for the character at the current
     cursor position.

     (Ignores numeric arguments).

     See also:  report-position.




report-position  Esc-=

     The report-position command displays the line and column of
     the cursor on the screen, and its location in the current
     buffer.

     (Ignores numeric arguments).

     See also:  report-character.

















                                                                    9-27
SAIL EDITING ENVIRONMENT




reset-global-mode  Esc-D                                        (Delete)

     The reset-global-mode command is used to reset (turn off)
     modes assigned to the current buffer.  In general, because
     the global mode settings are used only when SAIL reads a
     buffer from disk, the reset-global-mode command is used from
     an executable file.  One of the five mode names (CMODE,
     EXACT, OVER, VIEW, or WRAP) must follow the command, finally
     followed by Return.

     (Ignores numeric arguments).

     See also:  mode, set-global-mode, set-mode, reset-mode.




reset-mode  ^XR                                                  (Reset)

     The reset-mode command is used to reset (turn off) modes
     assigned to the current buffer.  You can also accomplish this
     by using the mode screen (F10).  In general, the reset-mode
     command is used for changing modes temporarily.

     The command prompts you to enter one of the five mode names
     (CMODE, EXACT, OVER, VIEW, or WRAP).  Enter one of the five
     mode names, followed by Return.

     (Ignores numeric arguments).

     See also:  mode, set-global-mode, set-mode,
                reset-global-mode.



















9-28
                                                       COMMAND REFERENCE




right  Right

     The right command moves the cursor one character to the right
     in the buffer.  If the cursor is at the end of the current
     line, it is moved to the beginning of the next line.

     (Uses numeric arguments).

     See also:  left.




roll-down  ^PgUp

     The roll-down command scrolls the current window down by one
     line.  If the cursor is on the last line of the window when
     scrolling is done, it is moved to the middle of the window.

     (Uses numeric arguments).

     See also:  roll-up.




roll-up  ^PgDn

     The roll-up command scrolls the current window up by one
     line.  If the cursor is on the first line of the window when
     scrolling is done, it is moved to the middle of the window.

     (Uses numeric arguments).

     See also:  roll-down.
















                                                                    9-29
SAIL EDITING ENVIRONMENT




save-file  Alt-S                                                  (Save)

     The save-file command prompts for a file name, and writes the
     current buffer to that file.  If the file already exists, it
     is overwritten, erasing the file's previous contents.

     If you do not provide a file name in response to the prompt,
     SAIL ignores this command.

     (Ignores numeric arguments).

     See also:  quit, write-file, zap.




search-back  ^R                                                (Reverse)

     The search-back command searches the buffer backward for a
     string that you specify.  It is identical in every way to the
     search-forward command, except that the search is done in
     reverse (toward the beginning of the buffer).

     (Uses numeric arguments).

     See also:  query-replace, replace, re-search-back,
                re-search-forward, search-forward.




search-forward  ^S                                              (Search)

     The search-forward command searches the buffer forward for a
     string that you specify.  In order to complete the command,
     SAIL requires you to complete the search string.  When SAIL
     prompts you for the search string, enter the string to search
     for, followed by the Esc key.

          Note that if you have previously used any of the
          search commands, there will be a proposed response
          for the search string.  Unless you enter a new
          string, the proposed response is used.  For the
          first search in an editing session, there will not
          be a proposed response.

     The behavior of searching depends on the setting of the Exact
     mode.  If Exact mode is set, searching is case-sensitive (capitals
     and lower case letters are significant);  if Exact mode is reset,
     searching is done without regard to case.

9-30
                                                       COMMAND REFERENCE




     (Uses numeric arguments).

     See also:  query-replace, replace, re-search-back,
                re-search-forward, search-back.




set-global-mode  Esc-A                                             (Add)

     The set-global-mode command is used to set (turn on) global
     modes.  In general, because the global mode settings are used
     only when SAIL reads a buffer from disk, the set-global-mode
     command is used from an executable file.  One of the five
     mode names (CMODE, EXACT, OVER, VIEW, or WRAP) must follow
     the command, finally followed by Return.

     (Ignores numeric arguments).

     See also:  mode, set-mode, reset-global-mode, reset-mode.




set-margin  ^XF                                                   (Fill)

     The set-margin command is used to change the margin that
     determines where lines are wrapped.  To change the margin,
     enter a repeat command, followed by the set-margin command
     (^XF).  For example, "Esc-72^XF" sets the right margin to
     column 72.

     The right margin is most commonly set automatically whenever
     SAIL is called by the use of the set-margin command within
     the SAIL.SET file.  See the example in the SAIL.SET file
     which is included in your SAIL distribution disk.

     See also:  justify.













                                                                    9-31
SAIL EDITING ENVIRONMENT




set-mark  Esc-Space

     The set-mark command sets the begin-block mark at the current
     buffer location to indicate the start of the block for use in
     block commands.

     (Ignores numeric arguments).

     See also:  caps-block, copy-block, delete-block, lower-block,
                swap-mark.




set-mode  ^XS                                                      (Set)

     The set-mode command is used to set (turn on) modes assigned
     to the current buffer.  You can also accomplish this by using
     the mode screen (F10).  In general, the set-mode command is
     used for changing modes temporarily.

     The command prompts you to enter one of the five mode names
     (CMODE, EXACT, OVER, VIEW, or WRAP).  Enter one of the five
     mode names, followed by Return.

     (Ignores numeric arguments).

     See also:  mode, set-global-mode, reset-global-mode,
                reset-mode.




shrink  ^D                                                        (Down)

     The shrink command shrinks the height of the current window
     by one line, while increasing the adjacent window by one
     line.  This command is valid only when there is more than one
     window on the screen.  In addition, there must be space
     remaining in the current window to shrink (the current window
     must be larger than one line).

     (Uses numeric arguments).

     See also:  enlarge.






9-32
                                                       COMMAND REFERENCE




space  Space                                                     (Space)

     The space command inserts a space into the current line at
     the cursor, leaving the cursor position unchanged.

     (Uses numeric arguments).

     See also:  tab.




split  Alt-2                                                       (Two)

     The split command splits the current window into two smaller
     windows.  The new window is an exact duplicate of the current
     window, with the same buffer name and the same file name.
     One of the windows will become the current window.  The
     remaining window(s) will be inactive.

     Use the split command, in addition to the shrink, enlarge,
     window-down, window-up, next-buffer, and previous next-buffer
     commands, to display text for comparison in the same file, or
     information between two files.

     (Ignores numeric arguments).

     See also:  close-other-windows.




swap-mark  ^X-Space

     The swap-mark command sets the begin-block mark at the
     current cursor position and moves the cursor to the last
     begin-block mark.

     (Ignores numeric arguments).

     See also:  set-mark.










                                                                    9-33
SAIL EDITING ENVIRONMENT




tab  Tab                                                           (Tab)

     The tab command inserts space(s) at the cursor, moving the
     cursor to the next tab stop.  If the tab command is preceded
     by a positive, nonzero, numeric argument, that numeric
     argument is taken as the number of spaces per tab stop.  If
     the numeric argument is zero, the tabs are changed to hard
     tabs (Hex 0x08).

     (Uses numeric arguments).

     See also:  space.




test-key  Esc-?

     The test-key command prompts for a key to describe.  Upon
     entry of a valid SAIL command, the key's name, and the
     mnenonic name assigned to that key, will be displayed.

     (Ignores numeric arguments).

     See also:  help.




top  ^Home

     The top command moves the cursor to the first character of
     the current buffer.

     (Ignores numeric arguments).

     See also:  bottom.














9-34
                                                       COMMAND REFERENCE




up  Up                                                              (Up)

     The up command moves the cursor to the previous line;
     maintaining the cursor's column position, or seeking the
     column closest to the current column.

     (Uses numeric arguments).

     See also:  down.




view-file  Alt-V                                                  (View)

     The view-file command prompts for the name of a file to view
     (edit in View mode).  If the name given is the name of an
     existing buffer, that buffer is selected;  otherwise, SAIL
     creates a new buffer, reads the disk file's contents, if
     present, into the buffer, then selects that buffer.  In
     addition, SAIL sets the buffer's attributes to VIEW mode,
     preventing modification of that file.

     If the file name (taken from the path name given) is already
     being used by another buffer, SAIL prompts for a new name for
     the buffer.

     (Ignores numeric arguments).

     See also:  edit-file.





















                                                                    9-35
SAIL EDITING ENVIRONMENT




window-down  ^XN                                                  (Next)

     If no numeric argument had been provided, the window-down
     command places the cursor in the next window (down) on the
     screen, or, if the cursor had been in the last window on the
     screen, places the cursor in the first window.

     If a numeric argument had been provided, this command places
     the cursor in the nth window from the top of the screen.  The
     n is the numeric argument that precedes the command (entered
     by Esc followed by a number or ^V).

     If there is only one window on the screen, this command is
     ignored.

     (Uses numeric arguments).

     See also:  window-up.




window-up  ^XP                                                (Previous)

     If no numeric argument had been provided, the window-up
     command places the cursor in the next window (up) on the
     screen, or, if the cursor had been in the first window on the
     screen, places the cursor in the last window.

     If a numeric argument had been provided, this command places
     the cursor in the nth window from the bottom of the screen.
     The n is the numeric argument that precedes the command
     (entered by Esc followed by a number or ^V).

     If there is only one window on the screen, this command is
     ignored.

     See also:  window-down.













9-36
                                                       COMMAND REFERENCE




word-left  ^Left

     The word-left command moves the cursor to the beginning of
     the next word to the left.  If the cursor is in the middle of
     a word, the cursor moves to the beginning of that word.  If
     the cursor is at the beginning of the first word of a line,
     this command moves the cursor to the beginning of the last
     word on the previous non-blank line.  In moving, if
     punctuation marks are encountered, they are considered to be
     parts of words.

     (Uses numeric arguments).

     See also:  word-right.




word-right  ^Right

     The word-right command moves the cursor to the beginning of
     the next word to the right.  If the cursor is in the last
     word of a line, this command moves the cursor to the
     beginning of the next non-blank line.  In moving, if
     punctuation marks are encountered, they are considered to be
     parts of words.

     (Uses numeric arguments).

     See also:  word-left.





















                                                                    9-37
SAIL EDITING ENVIRONMENT




write-file  Alt-W                                                (Write)

     The write-file command writes, without confirmation, the
     current buffer to the file associated with the buffer.  If
     the file already exists, it is overwritten, thus erasing any
     of the file's previous contents.

          Note that the buffer must have a file name in order
          for this command to be carried out.  If there is
          currently no file associated with the buffer, SAIL
          reports it as an error.

     (Ignores numeric arguments).

     See also:  quit, save-file, zap.




zap  Alt-Z                                                         (Zap)

     The zap command performs the write command on all buffers in
     the current session that have been changed but not saved.
     After updating all of the disk files, SAIL exits to DOS.
     This command is a shortcut way of doing the write command on
     all of the buffers, followed by the quit command.

     If an error occurs during file write, after writing all files
     that can be written, SAIL asks you for confirmation (in
     abandoning changed buffers) as in the quit command.

     (Ignores numeric arguments).

     See also:  quit, save-file, write-file.

















9-38


                                                                MESSAGES







APPENDIX A  MESSAGES



<n> substitutions


     When using the replace or query_replace commands, SAIL
     reports the number of substitutions.



Abandon unsaved changes?


     The command will cause SAIL to exit to the operating system.
     Any unsaved changes will not be saved to disk.  If you answer
     'n' SAIL will resume editing as if the command were not
     entered.  If you answer 'y', SAIL will exit to the operating
     system, abandoning any changes to unsaved buffers in the
     current session.



Begin key macro


     SAIL is waiting for you to enter a key sequence to be stored
     for later execution with the execute_macro command.  When you
     receive this prompt, enter a sequence of characters and/or
     SAIL commands, and follow them with the end_macro command.



Begin-block mark set


     Before a block command can be used, the start of the block
     must be marked with the set_mark command.  SAIL displays this
     message whenever you enter a set_mark command.







                                                                     A-1
SAIL EDITING ENVIRONMENT




Buffer to execute:


     SAIL is waiting for you to enter the name of the buffer to be
     executed.



Cannot allocate <n> bytes


     SAIL ran out of memory while attempting to read the specified
     file.  If the file was very long, it may have been truncated
     (the latter portion of it is erased).  Therefore, if you save
     the current buffer to disk, file on disk may be erased.  For
     best results, begin a new session immediately.  Save all
     files except the file that could not fit in memory, and
     reedit the file(s) by breaking the editing task into several
     smaller files before another editing session.



Cannot allocate block


     SAIL ran out of memory while attempting to allocate memory.
     Save all your changes and reduce the number of buffers,
     before editing again.



Cannot create buffer


     The specified buffer could not be created due to a disk
     error, or because of a naming conflict.














A-2
                                                                MESSAGES




Cannot edit in view mode


     Editing is restricted for files read in View mode.  If you
     really want to edit, the editing restriction for View mode
     can be removed by resetting the view mode (with the
     reset_mode command) for the buffer in question.



Cannot enlarge one-window screen


     Since the enlarge command is valid only when there are two or
     more buffers being displayed on the screen, the enlarge
     command is appropriate only after a command that splits the
     display into two or more windows.



Cannot enlarge window


     SAIL displays this message if the enlarge command is entered,
     and the result of the enlargement will cause one of the
     windows on the screen to shrink to less than two lines.



Cannot list key assignments


     Output if the list_keys command was entered and the key
     assignments could not be listed successfully due to a buffer
     naming conflict.















                                                                     A-3
SAIL EDITING ENVIRONMENT




Cannot nest key macros


     The begin_macro command was entered while input was already
     being accepted for a macro started by a previous begin_macro
     command.  Key macros cannot be embedded within other key
     macros.



Cannot open file for writing


     A disk error occurred when the specified file was to be
     written.



Cannot select built-in buffer


     SAIL reserves temporary buffer names for internal
     operations.  This message is displayed if you have specified
     a name that conflicts with the list of reserved names.



Cannot shrink one-window screen


     Since the shrink command is valid only when there are two or
     more buffers being displayed on the screen, the shrink
     command is appropriate only after a command that splits the
     display into two or more windows.



Cannot shrink window


     The window is already at its minimum size, preventing further
     shrinking of the window.








A-4
                                                                MESSAGES




Cannot split a <n> line window


     Windows smaller than three lines cannot be split.  Reduce the
     number of windows on the screen.



Can't delete a displayed buffer


     An attempt was made to delete a buffer that is currently
     being displayed on the screen.  To delete the buffer, detach
     it from the screen.



Creating buffer list


     SAIL is in the process of creating the list of key
     assignments in response to the entry of the describe_keys
     command.



[Delete buffer] Enter buffer name:


     SAIL is waiting for you to enter the name of the buffer to
     delete.



Deleted toward top of file


     During a delete operation, because a negative number prefixed
     the delete command, the delete area began at the current line
     and went toward the top of the file.  This is not an error,
     but a reminder to the operator that the delete direction was
     reversed.








                                                                     A-5
SAIL EDITING ENVIRONMENT




Discard changes?


     This prompt appears whenever you attempt to read in a file
     over an (edited) buffer with the same name, because the read
     operation will cause the file to replace your buffer, and, as
     a consequence, your changes to the buffer will be lost.



[Edit file] Enter file/path name:


     SAIL is waiting for you to input the name of the file to
     edit.  When you input a filename, SAIL searches for a buffer
     of that name edited in the current session, and if so,
     switches control to the buffer.  If SAIL could not find a
     previously-edited buffer, it creates a buffer with that name,
     and reads in the text, if existing, associated with it.



Editing the existing buffer


     This message is displayed whenever an edit_file command is
     entered, and SAIL is editing the existing buffer instead of
     reading new information from disk.



End key macro


     This message appears when you enter the command to end a key
     macro.














A-6
                                                                MESSAGES




Error in closing file


     An error occurred when SAIL attempted to close a file.
     Indicates a disk error.  Note that since this message really
     means that SAIL was not successful in completely saving your
     file, you should first try to recover from this situation by
     an attempt to save (using the save command) the buffer again
     under a different name.



Error in writing file


     An error occurred when SAIL attempted to write your file.
     Indicates a disk error.  Correct the problem (disk drive door
     open, bad floppy, etc.) and save the buffer again.



Error while deleting


     An error occurred while carrying out the delete command on
     your buffer.



[Execute buffer] Enter file/path name:


     SAIL is waiting for you to enter a name of a buffer which
     will be interpreted as an executable buffer.



[Execute file] Enter file/path name:


     SAIL is waiting for you to enter a name of a file which will
     be interpreted as an executable file.








                                                                     A-7
SAIL EDITING ENVIRONMENT




File not found


     The file that you specified for SAIL to read was not in the
     current directory.  This could have been caused by your being
     in the wrong subdirectory, the wrong disk being inserted, or
     a typo in the filename.



File read error


     An error occurred when SAIL attempted to read your file.
     Indicates a disk error.  For best results, keep your disks
     clean, and in their protective sleeves.



Function not defined


     An attempt was made to assign a key to an undefined function,
     or a command line error in a SAIL control file.



Help file not online


     For the online help facility to be available to you while
     editing, the help information, in a file named SAILHELP.EXE,
     must be available.  Read the section entitled "EXECUTION
     ENVIRONMENT" in Chapter 2 or the installation instructions on
     the distribution disk to make SAILHELP.EXE visible to SAIL.















A-8
                                                                MESSAGES




Hit RETURN to continue


     SAIL has completed processing the specified DOS command, and
     is ready to resume editing when you press RETURN.



Internal error


     This error message should never be displayed.  If you
     encounter this error, please make a list of the details of
     the conditions that caused it, and send Software Creations a
     Software Problem Report.  Thank you for your cooperation.



Interrupt


     While SAIL was waiting for the second half of a command, you
     entered ^C, which is the instruction to abort the command.



Invalid mode


     In response to the delete_mode or add_mode commands, a
     character string other than WRAP, CMODE, SPELL, EXACT, VIEW,
     or OVER was entered.



Key assignment table full


     The key assignment table holds up to 200 key assignments.
     This message is displayed if that number is exceeded.










                                                                     A-9
SAIL EDITING ENVIRONMENT




Key macro end without begin


     The end_macro command was entered, even though the
     begin_macro command was not.



Key macro incomplete or undefined


     An attempt was made to execute a key macro while it was still
     being defined.  This message is output if the execute_macro
     command was entered following the begin_macro command, and
     the end_macro command had not been entered.



Key not assigned


     An undefined key was entered following the Esc key or ^X;  or
     with the Ctrl key shifted down.



Last line incomplete


     The last line of the file did not contain a newline.  SAIL
     added it for you.



Line:  <n> Column:  <n> Character <n> of <n> (<n>%)


     The above appears on the message line when the file status is
     taken.  Line and Column are numbers indicating the position
     of the current line on the screen.  Character <n> of <n>
     shows the position of the current line with respect to the
     length of the file in bytes, and its percentage.








A-10
                                                                MESSAGES




Long line(s) in file


     SAIL read a file containing lines that were longer than 253
     letters.  Since SAIL reserves 253 letters for each line, long
     lines are automatically split.



Margin set to <n>


     When you change the right margin, SAIL displays this message
     to tell you which column it just set.



[Merge file] Enter file/path name:


     SAIL is waiting for you to type the name of the file to be
     merged into the current buffer.  Type the name of the file
     and press Return.



Merged <n> line(s), long lines wrapped


     While SAIL was merging the specified file into your current
     buffer, it found that your file had very long lines in it and
     wrapped them (automatically added newlines).



Merged <n> lines


     SAIL successfully merged the specified file into your current
     buffer, and is reporting the number of lines that were
     merged.









                                                                    A-11
SAIL EDITING ENVIRONMENT




Merging "filename"


     SAIL is in the process of merging the specified file into
     your current buffer.



New file


     SAIL is beginning processing on a new file.



No mark set in this window


     A block command was attempted without first setting a begin-
     block mark with a set_mark command.



No next window to page up


     The page_up_next command is valid only when there are two or
     more buffers being displayed on the screen.



No next window to page down


     The page_down_next command is valid only when there are two
     or more buffers being displayed on the screen.














A-12
                                                                MESSAGES




No previous search string


     An attempt was made to repeat a search, without a previous
     search.



Out of memory during insert


     Since an insert command requires that the file become larger,
     this message is displayed if the insert caused SAIL to run
     out of memory.



Pattern not found


     The specified search string could not be found from the
     current cursor position to the bottom (or top) of the file
     when the search (or reverse_search) command was entered.



Read <n> lines


     SAIL has successfully read the file from disk, and displays
     the number of lines read.



Read <n> lines, long lines wrapped


     SAIL has read the file from disk, but encountered lines
     having more than 256 characters in them.  These were split
     into lines shorter than 256 characters by addition of
     carriage returns.









                                                                    A-13
SAIL EDITING ENVIRONMENT




[Read file] Enter file/path name:


     SAIL is prompting you to enter the name of a file for use
     with the read_file command.



Reading...


     SAIL is reading the file from disk.



[Rename buffer] Enter new buffer name:


     SAIL is waiting for a new name for the current buffer.



Repeat:  <n>


     When a repeat prefix is entered, SAIL indicates the number of
     times that the command immediately following will be
     executed.



Reverse search ()[Esc]:


     When you enter the reverse_search command, SAIL displays this
     message to indicate that the search will be done toward the
     top of the file.  Enter the search string, followed by the
     Esc key.












A-14
                                                                MESSAGES




[Save file] Enter file/path name:


     SAIL is waiting for you to enter a filename (or a full DOS
     pathname) to use when saving the buffer.  Provide a name that
     you have not yet used for a file name.



Search ()[Esc]:


     When you enter the search command, SAIL displays this message
     to indicate that the search will be done toward the bottom of
     the file.  Enter the search string, followed by the Esc key.



Undefined function


     An attempt was made to assign a key illegally.



[Use buffer] Enter buffer name:


     SAIL is waiting for you to enter the name of a buffer to
     edit.  If the buffer has been edited in the current session,
     the contents of the buffer are used.  If the buffer does not
     exist, a new buffer with that name (and no filename) is
     created.



[View file] Enter file/path name:


     SAIL is waiting for you to enter the name of the file to
     View.









                                                                    A-15
SAIL EDITING ENVIRONMENT




Writing "filename"


     SAIL flashes the name of each file it saves while it
     processes the zap command.



Wrote <n> lines to "filename"


     SAIL successfully wrote the file to disk, and displays the
     number of lines written.





































A-16


                                                           COMMAND INDEX







APPENDIX B  COMMAND INDEX


Command name                    Key          Mnemonic
---------------------------------------------------------------------------
Abort command                   ^C
Add global mode                 Esc-A        set_global_mode
Assign key function             Esc-K        assign_key
Begin key macro                 Esc-(        begin_macro
Beginning of buffer             ^-Home       top
Beginning of line               ^-Up         bol
Beginning of paragraph          Home         bop
Blank screen                    F10          blank_screen
Buffer directory                Alt-D        list_buffers
Call DOS                        Alt-O        dos_shell
Carriage return                 ^M           newline
Center cursor in window         ^P           center_cursor
Close other windows             Alt-1        close_other_windows
Copy block to notepad           Esc-C        copy_block
Cursor back one word            ^-Left       word_left
Cursor down                     Down         down
Cursor down one page            PgDn         page_down
Cursor left                     Left         left
Cursor right                    Right        right
Cursor right one word           ^-Right      word_right
Cursor to begin-block mark      ^X           swap_mark
Cursor to next window           ^XN          window_down
Cursor to previous window       ^XP          window_up
Cursor up                       Up           up
Cursor up one page              PgUp         page_up
Delete blank lines              ^XD          delete_blank_lines
Delete block                    Esc-Y        delete_block
Delete buffer                   Alt-K        delete_buffer
Delete global mode              Esc-D        reset_global_mode
Delete left                     ^H           delete_left
Delete one word left            ^-BS         delete_word_left
Delete one word right           ^-Del        delete_word_right
Delete paragraph                ^Y           delete_paragraph
Delete right                    Del          delete_right
Delete to end of line           ^XY          delete_to_eol
Describe key                    Esc-?        test_key
DOS command                     Alt-C        dos_command
Edit another file               Alt-E        edit_file




                                                                     B-1
SAIL EDITING ENVIRONMENT




End key macro                   Esc-)        end_macro
End of buffer                   ^-End        bottom
End of line                     ^-Down       eol
End of paragraph                End          eop
Enlarge window                  ^U           enlarge
Exchange two letters            ^XE          exchange
Execute buffer                  Esc-B        execute_buffer
Execute command                 Esc-X        execute_command
Execute file                    Esc-F        execute_file
Execute key macro               Esc-E        execute_macro
Execute line                                 execute_line
Free key                        ^XK          free_key
Go to line                      ^G           goto
Help                            F1           help
Indent                          ^J           newline_indent
Initial caps word               ^XI          capitalize_word
Insert newline                  ^N           open_line
Insert space                    Ins          space
Insert tab                      Tab          tab
Justify paragraph               Esc-J        justify
List key assignments                         list_keys
Lowercase block                 Esc-L        lower_block
Lowercase word                  ^XL          lower_word
Merge file                      Alt-M        merge_file
Next buffer                     Alt-N        next_buffer
Page next window down           ^Z           page_down_next
Page next window up             ^W           page_up_next
Pause 1 second                  SHF-F6       pause
Put back notepad                Esc-P        put
Query replace                   Esc-Q        query_replace
Quit                            Alt-Q        quit
Quote control character         ^XQ          quote_character
Read file                       Alt-R        read_file
Refresh screen                  ^L           redraw
Rename buffer                   Alt-B        rename_buffer
Rename file                     Alt-N        rename_file
Repeat search backward          ^B           re_search_back
Repeat search forward           ^F           re_search_forward
Replace                         Esc-R        replace
Report cursor character         ^X=          report_character
Report cursor position          Esc-=        report_position
Reset mode                      ^XR          reset_mode
Roll down                       ^-PgUp       roll_down
Roll up                         ^-PgDn       roll_up
Save and exit                   Alt-Z        write_quit
Save file                       Alt-S        save_file




B-2
                                                           COMMAND INDEX




Search backward                 ^R           search_back
Search forward                  ^S           search_forward
Set begin-block mark            Esc-         set_mark
Set mode                        ^XS          set_mode
Set right margin                ^XF          set_margin
Shrink window                   ^D           shrink
Split window                    Alt-2        split
Uppercase block                 Esc-U        caps_block
Uppercase word                  ^XU          caps_word
Use another buffer              Alt-U        edit_buffer
View file                       Alt-V        view_file
Write file                      Alt-W        write_file






































                                                                     B-3


                                                          MNEMONIC INDEX




APPENDIX C  MNEMONIC INDEX


Mnemonic name           Command name                      Key
---------------------------------------------------------------------------
assign_key              Assign key function               Esc-K
begin_macro             Begin key macro                   Esc-(
blank_screen            Blank screen                      F10
bol                     Beginning of line                 ^-Up
bop                     Beginning of paragraph            Home
bottom                  End of buffer                     ^-End
capitalize_word         Initial caps word                 ^XI
caps_block              Uppercase block                   Esc-U
caps_word               Uppercase word                    ^XU
center_cursor           Center cursor in window           ^P
close_other_windows     Close other windows               Alt-1
copy_block              Copy block to notepad             Esc-C
delete_blank_lines      Delete blank lines                ^XD
delete_block            Delete block                      Esc-Y
delete_buffer           Delete buffer                     Alt-K
delete_left             Delete left                       ^H
delete_paragraph        Delete paragraph                  ^Y
delete_right            Delete right                      Del
delete_to_eol           Delete to end of line             ^XY
delete_word_left        Delete one word left              ^-BS
delete_word_right       Delete one word right             ^-Del
dos_command             DOS command                       Alt-C
dos_shell               Call DOS                          Alt-O
down                    Cursor down                       Down
edit_buffer             Use another buffer                Alt-U
edit_file               Edit another file                 Alt-E
end_macro               End key macro                     Esc-)
enlarge                 Enlarge window                    ^U
eol                     End of line                       ^-Down
eop                     End of paragraph                  End
exchange                Exchange two letters              ^XE
execute_buffer          Execute buffer                    Esc-B
execute_command         Execute command                   Esc-X
execute_file            Execute file                      Esc-F
execute_line            Execute line                      (Unassigned)
execute_macro           Execute key macro                 Esc-E
free_key                Free key                          ^XK
goto                    Go to line                        ^G
help                    Help                              F1
justify                 Justify paragraph                 Esc-J
left                    Cursor left                       Left




                                                                     C-1
SAIL EDITING ENVIRONMENT




list_buffers            Buffer directory                  Alt-D
list_keys               List key assignments              (Unassigned)
lower_block             Lowercase block                   Esc-L
lower_word              Lowercase word                    ^XL
merge_file              Merge file                        Alt-M
newline                 Carriage return                   ^M
newline_indent          Indent                            ^J
next_buffer             Next buffer                       Alt-N
open_line               Insert newline                    ^N
page_down               Cursor down one page              PgDn
page_down_next          Page next window down             ^Z
page_up                 Cursor up one page                PgUp
page_up_next            Page next window up               ^W
put                     Put back notepad                  Esc-P
query_replace           Query replace                     Esc-Q
quit                    Quit                              Alt-Q
quote_character         Quote control character           ^XQ
re_search_back          Repeat search backward            ^B
re_search_forward       Repeat search forward             ^F
read_file               Read file                         Alt-R
redraw                  Refresh screen                    ^L
rename_buffer           Rename buffer                     Alt-B
rename_file             Rename file                       Alt-N
replace                 Replace                           Esc-R
report_character        Report cursor character           ^X=
report_position         Report cursor position            Esc-=
reset_global_mode       Delete global mode                Esc-D
reset_mode              Reset mode                        ^XR
right                   Cursor right                      Right
roll_down               Roll down                         ^-PgUp
roll_up                 Roll up                           ^-PgDn
save_file               Save file                         Alt-S
search_back             Search backward                   ^R
search_forward          Search forward                    ^S
set_global_mode         Add global mode                   Esc-A
set_margin              Set right margin                  ^XF
set_mark                Set begin-block mark              Esc-
set_mode                Set mode                          ^XS
shrink                  Shrink window                     ^D
space                   Insert space                      Ins
split                   Split window                      Alt-2
swap_mark               Cursor to begin-block mark        ^X
tab                     Insert tab                        Tab
test_key                Describe key                      Esc-?
top                     Beginning of buffer               ^-Home
up                      Cursor up                         Up




C-2
                                                          MNEMONIC INDEX




view_file               View file                         Alt-V
window_down             Cursor to next window             ^XN
window_up               Cursor to previous window         ^XP
word_left               Cursor back one word              ^-Left
word_right              Cursor right one word             ^-Right
write_file              Write file                        Alt-W
write_quit              Save and exit                     Alt-Z











































                                                                     C-3


                                                               KEY INDEX




APPENDIX D  KEY INDEX


Key          Mnemonic                  Command function
---------------------------------------------------------------------------
Alt-1        close_other_windows       Close other windows
Alt-2        split                     Split window
Alt-B        rename_buffer             Rename buffer
Alt-C        dos_command               DOS command
Alt-D        list_buffers              Buffer directory
Alt-E        edit_file                 Edit another file
Alt-K        delete_buffer             Delete buffer
Alt-M        merge_file                Merge file
Alt-N        next_buffer               Next buffer
Alt-N        rename_file               Rename file
Alt-O        dos_shell                 Call DOS
Alt-Q        quit                      Quit
Alt-R        read_file                 Read file
Alt-S        save_file                 Save file
Alt-U        edit_buffer               Use another buffer
Alt-V        view_file                 View file
Alt-W        write_file                Write file
Alt-Z        write_quit                Save and exit

Del          delete_right              Delete right
Down         down                      Cursor down
End          eop                       End of paragraph

Esc-         set_mark                  Set begin-block mark
Esc-(        begin_macro               Begin key macro
Esc-)        end_macro                 End key macro
Esc-=        report_position           Report cursor position
Esc-?        test_key                  Describe key
Esc-A        set_global_mode           Add global mode
Esc-B        execute_buffer            Execute buffer
Esc-C        copy_block                Copy block to notepad
Esc-D        reset_global_mode         Delete global mode
Esc-E        execute_macro             Execute key macro
Esc-F        execute_file              Execute file
Esc-J        justify                   Justify paragraph
Esc-K        assign_key                Assign key function
Esc-L        lower_block               Lowercase block
Esc-P        put                       Put back notepad
Esc-Q        query_replace             Query replace
Esc-R        replace                   Replace
Esc-U        caps_block                Uppercase block




                                                                     D-1
SAIL EDITING ENVIRONMENT




Esc-X        execute_command           Execute command
Esc-Y        delete_block              Delete block

Home         bop                       Beginning of paragraph
Ins          space                     Insert space
Left         left                      Cursor left
PgDn         page_down                 Cursor down one page
PgUp         page_up                   Cursor up one page
Right        right                     Cursor right
Tab          tab                       Insert tab
Up           up                        Cursor up

F1           help                      Help
F10          blank_screen              Blank screen

Shift-F5                               Trash files
Shift-F6                               Pause 1 second

^BS          delete_word_left          Delete one word left
^Del         delete_word_right         Delete one word right
^Down        eol                       End of line
^End         bottom                    End of buffer
^Home        top                       Beginning of buffer
^Left        word_left                 Cursor back one word
^PgDn        roll_up                   Roll up
^PgUp        roll_down                 Roll down
^Right       word_right                Cursor right one word
^Up          bol                       Beginning of line
^B           re_search_back            Repeat search backward
^C                                     Abort command
^D           shrink                    Shrink window
^F           re_search_forward         Repeat search forward
^G           goto                      Go to line
^H           delete_left               Delete left
^J           newline_indent            Indent
^L           redraw                    Refresh screen
^M           newline                   Carriage return
^N           open_line                 Insert newline
^P           center_cursor             Center cursor in window
^R           search_back               Search backward
^S           search_forward            Search forward
^U           enlarge                   Enlarge window
^W           page_up_next              Page next window up
^Y           delete_paragraph          Delete paragraph
^Z           page_down_next            Page next window down





D-2
                                                               KEY INDEX




^XSpace      swap_mark                 Cursor to begin-block mark
^X=          report_character          Report cursor character
^XD          delete_blank_lines        Delete blank lines
^XE          exchange                  Exchange two letters
^XF          set_margin                Set right margin
^XI          capitalize_word           Initial caps word
^XK          free_key                  Free key
^XL          lower_word                Lowercase word
^XN          window_down               Cursor to next window
^XP          window_up                 Cursor to previous window
^XQ          quote_character           Quote control character
^XR          reset_mode                Reset mode
^XS          set_mode                  Set mode
^XU          caps_word                 Uppercase word
^XY          delete_to_eol             Delete to end of line

[Unassigned] execute_line              Execute line
[Unassigned] list_keys                 List key assignments
































                                                                     D-3


                                                              EMACS MODE




APPENDIX E  uEMACS MODE

     If the -e switch is given on the command line when SAIL is
started, SAIL emulates uEMACS key assignments.  This is for users who
are familiar with EMACS on microcomputers and mainframes, and would
prefer EMACS-based key assignments.

     Note that while the help screens may be called in uEMACS mode,
they do not apply to this mode.  Software Creations does not recommend
this mode.

   Key  Command name                     Key  Command name
---------------------------------------------------------------------------
    ^A  Move to start of line             ^M   Insert CR-LF
    ^B  Move backward one character       ^N   Move forward one line
    ^C  Insert space                      ^O   Insert one blank line
    ^D  Delete forward                    ^P   Move backward one line
    ^E  Move to end of line               ^Q   Insert literal
    ^F  Move forward one character        ^R   Search backwards
    ^G  Abort command                     ^S   Search forward
    ^H  Delete backward                   ^T   Transpose characters
    ^I  Insert TAB                        ^V   Move forward one page
    ^J  Insert CR-LF, then indent         ^W   Delete block
    ^K  Delete forward                    ^Y   Put notepad
    ^L  Refresh screen                    ^Z   Move backward one page

   ^X!  Execute MS-DOS command           ^XF   Set fill column
   ^X(  Begin macro                      ^XK   Make a buffer go away
   ^X)  End macro                        ^XM   Set mode
   ^X1  Make current window one          ^XN   Rename current file name
   ^X2  Split current window             ^XO   Move to next window
   ^X=  Show cursor position             ^XP   Move to previous window
   ^X?  Describe key                     ^XS   Save current file
   ^XB  Switch a window to a buffer      ^XX   Use next buffer
   ^XC  Start new command processor      ^XZ   Enlarge display window
   ^XE  Execute macro                    ^X^   Enlarge display window

  ^X^B  Display buffer list             ^X^P   Move window up
  ^X^C  Exit SAIL                       ^X^R   Read file from disk
  ^X^F  Find file names                 ^X^S   Save current file
  ^X^I  Insert file                     ^X^U   Upper case block
  ^X^L  Lower case block                ^X^V   View file
  ^X^M  Reset mode                      ^X^W   Write file to disk
  ^X^N  Move window down                ^X^X   Swap "." and mark
  ^X^O  Delete blank lines              ^X^Z   Shrink window





                                                                     E-1
SAIL EDITING ENVIRONMENT




Esc-!   Reposition window              Esc-N   Move to end of paragraph
Esc-.   Set mark                       Esc-P   Move to top of paragraph
Esc-<   Move to start of buffer        Esc-Q   Justify current paragraph
Esc->   Move to end of buffer          Esc-R   Search and replace
Esc-B   Backup one word                Esc-rubout  Delete backward word
Esc-C   Initial capitalize word        Esc-space   Set mark
Esc-D   Delete forward word            Esc-U   Upper case word
Esc-F   Advance one word               Esc-V   Move backward one page
Esc-G   Go to line (use with repeat)   Esc-W   Copy block to memory buffer
Esc-K   Bind key to function           Esc-X   Execute named command
Esc-L   Lower case word                Esc-Z   Save file and exit
Esc-M   Set global mode

Alt-R   Hunt backward                  Alt-S   Hunt forward
Please define < replace w/prompts>:



Esc-^H  Delete backward word           Esc-^R  Search
Esc-^K  Reset key assignment           Esc-^V  Scroll next window down
Esc-^L  Reposition window              Esc-^W  Delete paragraph
Esc-^M  Delete global mode             Esc-^Z  Scroll next window up
Esc-^N  Rename current buffer          rubout  Backward delete

Unassigned commands:
---------------------------------------------------------------------------
  describe_key            Display the list of current key assignments
  execute_buffer          Execute a buffer od command lines
  execute_command_line    Execute a command line (n <command> <args>)
  execute_file            Execute a file of command lines
  execute_named_command   Execute a command by name (w/command completion)






















E-2


                                                          SPECIFICATIONS




APPENDIX F  SPECIFICATIONS


     Windows per screen:      12 maximum
     Buffers per session:     Limited only by memory
     Total file size:         About 260K for PC-AT with 640K




WINDOW LIMIT

     While SAIL provides for a maximum of 12 windows simultaneously
displayed on the screen, practical use shows us that it is difficult to
work with more than four windows on the screen at once (the windows are
too small to show enough information).  In future implementations, we
expect that SAIL will work well with 43 lines of text.



FILE SIZE LIMIT

     The upper limit for SAIL files is approximately 260K.

     This size varies, depending on the amount of memory in your
system, the number and size of memory-resident programs, the number of
buffers being edited and their size, and the contents of temporary
buffers such as the notepad.

     In our own experience, we like to work with files about 30K, which
is about the size of a long chapter.  Our experience shows that SAIL
works well editing files of that size, because SAIL was used
extensively for its own development and for preparation of this manual
...  and we like to do our software development in modules, and write
our manuals by chapters.



BUFFERS PER SESSION LIMIT

     While we have tested SAIL and know that it can successfully edit
more than 24 buffers at the same time, practice has shown us that it is
difficult to work with (and juggle) more than seven buffers at once.
When working with multiple buffers, it is a good idea to periodically
use the write or zap commands to save your work.  Incremental editing
produces the best results.




                                                                     F-1
SAIL EDITING ENVIRONMENT




HARDWARE REQUIREMENTS FOR SAIL

1.  IBM (TM) PC-, PC-XT-, PC-AT-, or PS/2-compatible computer with a
    minimum of 384K and one disk drive, running MS-DOS (R) or PC-DOS
    (TM) Version 2.10 or above.  SAIL was developed on and for, and
thus
    is most natural on, AT-class machines and newer high-speed
systems.
    However, SAIL has also been extensively tested and used on original
    IBM-PC equipment as well as compatibles both foreign and domestic,
    and performs well on those systems.

    Some compatible CGA boards, especially the newer ones, do not have
    the bus contention problem of the 100% compatible IBM CGA.

    If this is the case for your card, you can greatly speed up the
    display screen output by specifying the /S command line option.
    See the command line options help screen (Enter SAIL /HELP from
    the DOS command line).

    The 43-line EGA version of SAIL is not available for distribution
    as of this writing.



2.  384K RAM (640K recommended)

    So as to handle the multiple buffers, SAIL uses all the available
    memory.  SAIL works best with lots of RAM (especially if you want
    to edit more than 10 files at once).  SAIL can run on 256K
    computers, but you won't be able to use the help screens.



3.  Tested machines

    The following table lists all the machines which were tested by
    Software Creations when developing SAIL.  If you have run SAIL
    successfully on your computer and it is not listed here, please
    drop us a line.


     Hardware        Operating system  Display type

     IBM PC-XT       PC-DOS V3.20      CGA/EGA/mono
     IBM PC-AT       PC-DOS V3.00      CGA




F-2
                                                          SPECIFICATIONS




     Bullet 286-XT   MS-DOS V3.10      Paradise CGA
     Generic clone   PC-DOS V3.20      CGA with mono monitor
















































                                                                     F-3







SOFTWARE PROBLEM REPORT

     Since we have been very conservative in the coding of
machine-dependent routines, we expect that SAIL will run without
problems on most IBM compatibles.  However, due to the size of SAIL,
and the numerous system configurations now available, SAIL may not work
on all machines and configurations, all of the time.

     While we realize it can be upsetting for you to have a problem
with your software, it is not enough to merely point out that the
software won't work.

     So that we can receive your communication responsibly, and use it
as an opportunity to improve the software, we would like your
cooperation in the completion of Software Problem Reports.

     Software Problem Reports should be sent to:

Software Creations 99-583 Aliipoe Drive Aiea, HI 96701 USA

     If you would like a reply to your report, please include a
stamped, self-addressed envelope.

     Thank you very much.



























SAIL EDITING ENVIRONMENT




                          SOFTWARE PROBLEM REPORT

                                               Date ____________________


(1) Address for communications
    Name ______________________________________
    Address ___________________________________
            ___________________________________
    City ______________________________________
    State ________________   Zip ______________


(2) Type of problem
    ____ Manual error      ____ Software problem    ____ Other problem
          ____ Mistake          ____ Fatal
          ____ Typo             ____ Command
          ____ Unclear          ____ Intermittent


(3) System description

    (A) Hardware
        Manufacturer _________________________  Model type _____________
        Memory size ____________________________________________________
        Peripherals ____________________________________________________
                    ____________________________________________________

    (B) Media type
         Size                     Density               Sides
         3.5  inch ________       Single ________       Single _________
         5.25 inch ________       Double ________       Double _________
         8    inch ________       Quad   ________

    (C) Operating System
    Manufacturer _______________________________   Version _____________

    (D) RAM-Resident Utilities
    Manufacturer _______________________________   Version _____________
    Manufacturer _______________________________   Version _____________
    Manufacturer _______________________________   Version _____________















(4) Description of Problem

    Please describe the problem in detail.  When does the problem occur,
    and under what circumstances?  If possible, include a disk file along
    with a batch file, that demonstrates the problem.














































